#include <stdio.h>
#include <stdlib.h>
#include "terms.h"
#include "ga.h"

static Atom pnames[20];
static List mult_l(List lm1, List lm2);
List calc_tr(Term ga, int is_g5);
static List mlt_csf(List, List);
List add_flines(void);

List ave_l = 0;

extern int db[10];

Term td_prop=0, td_num=0;

Atom pmass[16];
	
int  HASH_SZ=213;
		
static List *hash=NULL;

static int prtcmp(Term p1, Term p2)
	{
	return strcmp(AtomValue(CompoundArg1(p1)),AtomValue(CompoundArg1(p2)));
	}

static int i_val(Term t)
{
	char *an, c;
	int no;
	
	if(is_label(t))
		return -LabelValue(t);
	an=AtomValue(t);
	c=an[0];
	sscanf(an+1,"%d",&no);
	if(no>200) no-=200-in_prt;
	if(no>100) no-=100;
	if(c=='m') no+=300;
	if(c=='q') no+=200;
	if(c=='e') no+=100;
	return no;
}

static int spcmp(Term t2, Term t1)
{	
	int ca1, ca2;
	ca1=CompoundArity(t1);
	ca2=CompoundArity(t2);
	if(ca1-ca2)
		return ca1-ca2;
	if(ca1==2) 
	return 1000*i_val(CompoundArg1(t1))+i_val(CompoundArg2(t1))
			-1000*i_val(CompoundArg1(t2))+i_val(CompoundArg2(t2));
	ca1=CompoundArg1(t1);
	ca2=CompoundArg1(t2);
	return i_val(ListNth(ca1,4))+i_val(ListNth(ca1,3))*400+
		i_val(ListNth(ca1,2))*160000+i_val(ListFirst(ca1))*64000000
	      - i_val(ListNth(ca2,4))-i_val(ListNth(ca2,3))*400-
		i_val(ListNth(ca2,2))*160000-i_val(ListFirst(ca2))*64000000;
}

static int can_val(Term m2)
{
	List ml;
	int val=0,deg=1;
	for(ml=CompoundArgN(m2,3);ml;ml=ListTail(ml))
	{
		Term sp;
		sp=ListFirst(ml);
		if(CompoundArity(sp)==2)
			val+=CompoundArg1(sp)*deg+CompoundArg2(sp)*2*deg;
		else
			val+=ListFirst(CompoundArg1(sp))*deg*27;
		deg*=2;
	}
	return val>0?val:-val;
}

static void can_m2(Term m2)
{
	List l1,l2,lp;
	lp=ConsumeCompoundArg(m2,2);
	
	l1=ConsumeCompoundArg(m2,3);
	for(l2=l1;l2;l2=ListTail(l2))
	{
		Term sp;
	
		sp=ListFirst(l2);
		if(CompoundName(sp)==OPR_SPECIAL && CompoundArg1(sp)==A_DELTA)
		{
			Label la1,la2;
			int iva1, iva2;
			la1=ListFirst(CompoundArg2(sp));
			la2=ListNth(CompoundArg2(sp),2);
			iva1=i_val(la1);
			iva2=i_val(la2);
			FreeAtomic(sp);
			
			if(iva1==iva2 && iva1<=in_prt+out_prt && pmass[iva1]==0)
			{
				/*List lll;*/
				
				SetCompoundArg(m2,1,NewInteger(0));
				/*
				lll=ListTail(l2);
				l1=CutFromList(l1,l2);
				l2=lll;
				if(pmass[iva1])
					lp=mlt_csf(lp,AppendLast(0,MakeCompound2(OPR_POW,
							pmass[iva1],NewInteger(2))));
				else
					SetCompoundArg(m2,1,NewInteger(0));
				if(lll)
					goto resu;
				else
					break;
				*/
			}
			
			if(iva1>iva2 && iva1-100==iva2)
			{
				SetCompoundArg(m2,1,NewInteger(0));
				
			}
			if(iva2>iva1 && iva2-100==iva1)
			{
				SetCompoundArg(m2,1,NewInteger(0));
				
			}
			if((iva1==101 && iva2==2) || (iva1==2 && iva2==101) ||
					 (iva1==102 && iva2==1) || (iva1==1 && iva2==102))
			{
				SetCompoundArg(m2,1,NewInteger(0));
				
			}
			if(iva1>iva2)
				ChangeList(l2,MakeCompound2(OPR_DIV,la1,la2));
			else
				ChangeList(l2,MakeCompound2(OPR_DIV,la2,la1));
			continue;
		}
		if(CompoundName(sp)==OPR_SPECIAL && CompoundArg1(sp)==A_I)
		{
			Label la[4];
			int val[4];
			int i,j,s;
			for(i=1;i<=4;i++)
			{
				la[i-1]=ListNth(CompoundArg2(sp),i);
				val[i-1]=i_val(la[i-1]);
			}
			s=1;
			for(i=0;i<3;i++)
			for(j=0;j<3;j++)
			if(val[j]<val[j+1])
			{
				int tmp;
				s*=-1;
				tmp=val[j]; val[j]=val[j+1]; val[j+1]=tmp;
				tmp=la[j];  la[j]= la[j+1];   la[j+1]=tmp;
			}
			if(la[0]==la[1] || la[1]==la[2] || la[2]==la[3])
				s=0;
			SetCompoundArg(m2,1,NewInteger(IntegerValue(CompoundArg1(m2))*s));
			FreeAtomic(sp);
			ChangeList(l2,MakeCompound1(A_I,MakeList4(la[0],la[1],la[2],la[3])));
			continue;
		}
			
		printf("Unknown spec ");WriteTerm(sp);puts("");exit(0);
	}
	l1=SortedList(l1,spcmp);
	SetCompoundArg(m2,3,l1);
	if(lp)
	{
		lp=SortedList(lp,prtcmp);
		SetCompoundArg(m2,2,lp);
	}	
}

static int a_c_r;

static List add_can(List l, Term m2)
{
	List l1,lp,ls;
	if(CompoundArg1(m2)==NewInteger(0))
	{
		FreeAtomic(m2);
		a_c_r=0;
		return l;
	}
	
	lp=CompoundArg2(m2);
	ls=CompoundArgN(m2,3);
	for(l1=l;l1;l1=ListTail(l1))
	{
		if(EqualTerms(CompoundArg2(ListFirst(l1)),lp) &&
				EqualTerms(CompoundArgN(ListFirst(l1),3),ls))
		{
			int no;
			no=IntegerValue(CompoundArg1(m2))+IntegerValue(CompoundArg1(ListFirst(l1)));
			a_c_r=0;
			if(no)
				SetCompoundArg(ListFirst(l1),1,NewInteger(no));
			else
				l=CutFromList(l,l1),a_c_r=-1;
			FreeAtomic(m2);
			return l;
		}
	}
	l=AppendFirst(l,m2);
	a_c_r=1;
	return l;
}
			
static Term lu_up_i(List *ci, Integer i)
{
	List l;
	Label la;
	for(l=*ci;l;l=ListTail(l))
		if(CompoundArg1(ListFirst(l))==i)
			return CompoundArg2(ListFirst(l));
	la=NewLabel();
	*ci=AppendLast(*ci,MakeCompound2(OPR_DIV,i,la));
	return la;
}

static void red_dlt(Term m2)
{
	List l1,l2,l3;
	Label av, ad;
	
	l1=ConsumeCompoundArg(m2,3);
rpt:
	for(l2=l1;l2;l2=ListTail(l2))
	{
		Term sp;
		sp=ListFirst(l2);
		if(CompoundName(sp)!=OPR_SPECIAL || CompoundArg1(sp)!=A_DELTA)
			continue;
		av=ListFirst(CompoundArg2(sp));
		ad=ListNth(CompoundArg2(sp),2);
		if(is_atom(av) && is_atom(ad))
		{
			char *nv, *nd;
			nv=AtomValue(av);
			nd=AtomValue(ad);
			if(nv[0]!='m' && nd[0]!='m' && nv[0]!='s' && nd[0]!='s')
				continue;
			if((nv[0]=='m' || nv[0]=='s') && (nd[0]!='m' && nd[0]!='s'))
			{
				Atom a3;
				a3=av;
				av=ad;
				ad=a3;
			}
		}
		if(is_atom(ad) && is_label(av))
		{
			Atom a3;
			a3=av;
			av=ad;
			ad=a3;
		}
		if(av==ad)
		{
			SetCompoundArg(m2,1,
					NewInteger(4*IntegerValue(CompoundArg1(m2))));
			l1=CutFromList(l1,l2);
			goto rpt;
		}
		l1=CutFromList(l1,l2);
		for(l2=l1;l2;l2=ListTail(l2))
			for(l3=CompoundArg2(ListFirst(l2));l3;l3=ListTail(l3))
				if(ListFirst(l3)==ad)
					ChangeList(l3,av);
		goto rpt;
	}
	SetCompoundArg(m2,3,l1);
}

static List mt_2_lmt(Term m2)
{
	List ls;
	List l1,l2;
	l1=NewList();
	


	ls=ConsumeCompoundArg(m2,3);
	l1=AppendLast(l1,AppendLast(0,m2));

	
		
	for(l2=ls;l2;l2=ListTail(l2))
	{
		Term sp;
		sp=ListFirst(l2);
		if(CompoundName(sp)==OPR_SPECIAL && CompoundArg1(sp)==A_DELTA)
		{
			m2=MakeCompound3(A_MTERM ,NewInteger(1),0,AppendLast(0,ListFirst(l2)));
			l1=AppendLast(l1,AppendLast(0,m2));
			continue;
		}
		if(CompoundName(sp)==OPR_SPECIAL && CompoundArg1(sp)==A_I)
		{
			m2=MakeCompound3(A_MTERM ,NewInteger(1),0,AppendLast(0,ListFirst(l2)));
			l1=AppendLast(l1,AppendLast(0,m2));
			continue;
		}
		if(CompoundName(sp)==A_MOMENT)
		{
			List ml,l3,la;
			Label ind;
			ml=ConsumeCompoundArg(ListFirst(l2),1);
			ind=ListFirst(CompoundArg2(ListFirst(l2)));
			FreeAtomic(ListFirst(l2));
			la=NewList();
			for(l3=ml;l3;l3=ListTail(l3))
			{
				int c,mn;
				mn=IntegerValue(ListFirst(l3));
				if(mn>0)
					c=1;
				else
					mn=-mn,c=-1;
				m2=MakeCompound3(A_MTERM,NewInteger(c),0,AppendLast(0,
						MakeCompound2(OPR_SPECIAL,A_DELTA,
						MakeList2(pnames[mn],ind))));
				la=AppendLast(la,m2);
			}
			l1=AppendLast(l1,la);
			continue;
		}
		if(CompoundName(sp)==A_GAMMA && CompoundArg1(sp)==0)
		{
			int is_g5=0;
			if(ListLength(CompoundArg2(sp))>6 && 
					is_label(ListFirst(CompoundArg2(sp))))
			{
				List l4;
				Label la;
				la=ListFirst(CompoundArg2(sp));
				for(l4=ls;l4;l4=ListTail(l4))
				{
					Term sp1=ListFirst(l4);
					if( (CompoundName(sp1)==OPR_SPECIAL && 
						 CompoundArg1(sp1)==A_I && 
						 ListFirst(CompoundArg2(sp))==la))
					{
						is_g5=1;
						break;
					}
				}
			}
			
			l1=AppendLast(l1,calc_tr(ListFirst(l2),is_g5));
			continue;
		}
		puts("Internal error (busi)");
		WriteTerm(sp);puts("");
		exit(0);
	}
	RemoveList(ls);
	
	{
		List p1,p2;
		p2=ListFirst(l1);
		for(p1=ListTail(l1);p1;p1=ListTail(p1))
			p2=mult_l(p2,ListFirst(p1));
		RemoveList(l1);
		l1=p2;
	}
		
	return l1;
}
	
static void mk_trace(Term m2)
{
	List ls,l1,lvi;
	Atom fi,ci;
	int trlen;
	lvi=NewList();
	
	
	ls=ConsumeCompoundArg(m2,3);
	
rpt:
	fi=ci=0;
	lvi=NewList();
	for(l1=ls;l1;l1=ListTail(l1))
	{
		Term sp;
		sp=ListFirst(l1);
		if(CompoundName(sp)==OPR_SPECIAL && CompoundArg1(sp)==A_GAMMA)
		{
			fi=ListFirst(CompoundArg2(sp));
			ci=ListNth(CompoundArg2(sp),2);
			lvi=AppendLast(lvi,ListNth(CompoundArg2(sp),3));
			ls=CutFromList(ls,l1);
			trlen=1;
			break;
		}
		if(CompoundName(sp)==OPR_SPECIAL && CompoundArg1(sp)==A_GAMMA5)
		{
			fi=ListFirst(CompoundArg2(sp));
			ci=ListNth(CompoundArg2(sp),2);
			lvi=AppendLast(lvi,0);
			ls=CutFromList(ls,l1);
			trlen=0;
			break;
		}
	}
	
	if(ci==0)
	{
		SetCompoundArg(m2,3,ls);
		return;
	}
	
	while(ci!=fi)
	{
		for(l1=ls;l1;l1=ListTail(l1))
		{
			Term sp;
			sp=ListFirst(l1);
			if(CompoundArg1(sp)==A_GAMMA && 
					ListFirst(CompoundArg2(sp))==ci)
			{
				ci=ListNth(CompoundArg2(sp),2);
				lvi=AppendLast(lvi,ListNth(CompoundArg2(sp),3));
				trlen++;
				ls=CutFromList(ls,l1);
				break;
			}
			if(CompoundArg1(sp)==A_GAMMA5 && 
					ListFirst(CompoundArg2(sp))==ci)
			{
				ci=ListNth(CompoundArg2(sp),2);
				lvi=AppendLast(lvi,0);
				ls=CutFromList(ls,l1);
				break;
			}
		}
		if(l1==0)
		{
			puts("Internal error (bu:ufs)");
			exit(0);
		}
	}
	
	if(trlen&1)
		SetCompoundArg(m2,1,NewInteger(0));
	else
	{
		List l2;
		int pos1;
		sg:
		pos1=0;
		for(l1=lvi;l1&&ListFirst(l1);l1=ListTail(l1)) pos1++;
		if(l1)
		{
			trlen=0;
			for(l2=ListTail(l1);l2&&ListFirst(l2);l2=ListTail(l2))
				trlen++;
			if(l2)
			{
				if(trlen&1)
					SetCompoundArg(m2,1,
							NewInteger(-IntegerValue(CompoundArg1(m2))));
				lvi=CutFromList(lvi,l1);
				lvi=CutFromList(lvi,l2);
				goto sg;
			}
			lvi=CutFromList(lvi,l1);
			if(ListLength(lvi)<4)
				SetCompoundArg(m2,1,NewInteger(0));
			else
			{
				List ll;
				if(pos1&1)
					SetCompoundArg(m2,1,
						NewInteger(-IntegerValue(CompoundArg1(m2))));
				ll=MakeList4(NewLabel(),NewLabel(),NewLabel(),NewLabel());
				lvi=ConcatList(CopyTerm(ll),lvi);
				ls=AppendLast(ls,MakeCompound2(OPR_SPECIAL,A_I,ll));
				
			}
		}
	}

	ls=AppendLast(ls,MakeCompound2(A_GAMMA,0,lvi));
	goto rpt;
}		

static List mlt_csf(List l1, List l2)
{
	List l;
	for(l=l2;l;l=ListTail(l))
	{
		Atom p;
		List l3;
		p=CompoundArg1(ListFirst(l));
		for(l3=l1;l3;l3=ListTail(l3))
			if(CompoundArg1(ListFirst(l3))==p)
				break;
		if(l3)
		{
			SetCompoundArg(ListFirst(l3),2,NewInteger(
					IntegerValue(CompoundArg2(ListFirst(l3)))+
					IntegerValue(CompoundArg2(ListFirst(l)))));
			ChangeList(l,0);
		}
		else
			l1=AppendLast(l1,ListFirst(l));
	}
	return l1;
}
			
	
static List mult_l(List lm1, List lm2)
{
	List l1,lres;
	lres=0;
	for(l1=lm2;l1;l1=ListTail(l1))
	{
		Term m2;
		List l2,l3;
		m2=ListFirst(l1);
		if(ListTail(l1))
			l2=CopyTerm(lm1);
		else
			l2=lm1;
		for(l3=l2;l3;l3=ListTail(l3))
		{
			Term m2a;
			List l4;
			m2a=ListFirst(l3);
			SetCompoundArg(m2a,1,NewInteger(
					IntegerValue(CompoundArg1(m2a))*IntegerValue(CompoundArg1(m2))));
			l4=ConsumeCompoundArg(m2a,2);
			l4=mlt_csf(l4,CopyTerm(CompoundArg2(m2)));
			SetCompoundArg(m2a,2,l4);
			l4=ConsumeCompoundArg(m2a,3);
			l4=ConcatList(l4,CopyTerm(CompoundArgN(m2,3)));
			SetCompoundArg(m2a,3,l4);
		}
	lres=ConcatList(lres,l2);
	}
	FreeAtomic(lm2);
	return lres;
}

static List rm_e2(Term m2)
{
	List l1;
	int eno=0;
	List gs=NewList();
	for(l1=CompoundArgN(m2,3);l1;l1=ListTail(l1))
		if(CompoundName(ListFirst(l1))==OPR_SPECIAL &&
				CompoundArg1(ListFirst(l1))==A_I)
		{
			gs=AppendLast(gs,l1);
			eno++;
		}
	if(eno>1)
	{
		Term e1,e2;
		List lc;
		Term la,la1[3],la2[3];
		int i,j,s;
		
		if(eno>2)
		{
			printf("\nThe expression contains %d eps\n",eno);
			exit(0);
		}
		e1=ListFirst(gs);
		e2=ListFirst(ListTail(gs));
		RemoveList(gs);
		la=0;
		
		for(gs=CompoundArg2(ListFirst(e1));gs;gs=ListTail(gs))
			if((is_label(ListFirst(gs)) || 
					AtomValue(ListFirst(gs))[0]=='m') &&
					ListMember(CompoundArg2(ListFirst(e2)),ListFirst(gs)))
			{
				la=ListFirst(gs);
				break;
			}
		if(!la)
			return AppendLast(0,m2);
		
		lc=ConsumeCompoundArg(m2,3);
		j=0;
		s=1;
		for(gs=CompoundArg2(ListFirst(e1));gs;gs=ListTail(gs))
			if(ListFirst(gs)==la)
				i=j;
			else
				la1[j++]=ListFirst(gs);
		if(i&1)
			s*=-1;
		j=0;
		for(gs=CompoundArg2(ListFirst(e2));gs;gs=ListTail(gs))
			if(ListFirst(gs)==la)
				i=j;
			else
				la2[j++]=ListFirst(gs);
		if(i&1)
			s*=-1;
		
		lc=CutFromList(lc,e1);
		lc=CutFromList(lc,e2);
/*		
		for(i=0;i<3;i++) WriteTerm(la1[i]),printf(" ");
		puts("");
		for(i=0;i<3;i++) WriteTerm(la2[i]),printf(" ");
		puts("");
*/		
		s*=IntegerValue(CompoundArg1(m2));
		gs=NewList();
		gs=AppendLast(gs,MakeCompound3(A_MTERM,NewInteger(s),
				CopyTerm(CompoundArg2(m2)),ConcatList(CopyTerm(lc),MakeList3(
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[0],la2[0])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[1],la2[1])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[2],la2[2]))))));
		gs=AppendLast(gs,MakeCompound3(A_MTERM,NewInteger(-s),
				CopyTerm(CompoundArg2(m2)),ConcatList(CopyTerm(lc),MakeList3(
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[0],la2[0])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[1],la2[2])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[2],la2[1]))))));
		gs=AppendLast(gs,MakeCompound3(A_MTERM,NewInteger(-s),
				CopyTerm(CompoundArg2(m2)),ConcatList(CopyTerm(lc),MakeList3(
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[0],la2[1])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[1],la2[0])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[2],la2[2]))))));
		gs=AppendLast(gs,MakeCompound3(A_MTERM,NewInteger(s),
				CopyTerm(CompoundArg2(m2)),ConcatList(CopyTerm(lc),MakeList3(
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[0],la2[1])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[1],la2[2])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[2],la2[0]))))));
		gs=AppendLast(gs,MakeCompound3(A_MTERM,NewInteger(s),
				CopyTerm(CompoundArg2(m2)),ConcatList(CopyTerm(lc),MakeList3(
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[0],la2[2])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[1],la2[0])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[2],la2[1]))))));
		gs=AppendLast(gs,MakeCompound3(A_MTERM,NewInteger(-s),
				CopyTerm(CompoundArg2(m2)),ConcatList(CopyTerm(lc),MakeList3(
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[0],la2[2])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[1],la2[1])),
				MakeCompound2(OPR_SPECIAL,A_DELTA,MakeList2(la1[2],la2[0]))))));

		FreeAtomic(m2);
		if(lc) FreeAtomic(lc);
		return gs;
	}
	return AppendLast(0,m2);
}

static Term mom_square(List p)
{
	Term m2;
	Label la;
	List l;
	la=NewLabel();
	m2=MakeCompound(A_MTERM, 3);
	SetCompoundArg(m2,1,NewInteger(-1));
	SetCompoundArg(m2,3,MakeList2(
			MakeCompound2(A_MOMENT,CopyTerm(p),AppendLast(0,la)),
			MakeCompound2(A_MOMENT,CopyTerm(p),AppendLast(0,la))));
	m2=mt_2_lmt(m2);
	p=NewList();
	for(l=m2;l;l=ListTail(l))
	{
		red_dlt(ListFirst(l));
		can_m2(ListFirst(l));
		if(CompoundArg1(ListFirst(l))==NewInteger(0))
		{
			FreeAtomic(ListFirst(l));
			continue;
		}
		p=add_can(p,ListFirst(l));
	}
	RemoveList(m2);
	return p;
}
			
int build_diag(Term diag)
{
	List l,ci,ee,props;
	int vno=0,pno,i;	
	diag=CompoundArg2(diag);
	
	ee=NewList();
	props=NewList();
	
	if(hash==NULL)
	hash=malloc(sizeof(List)*HASH_SZ);
	if(hash==NULL)
	{
		puts("Can not allocate memory for mterm hash");
		return 0;
	}
	
	{
		char cbuf[20];
		int i;
		for(i=1;i<=in_prt+out_prt;i++)
		{
			sprintf(cbuf,"p%d",i);
			pnames[i]=NewAtom(cbuf,2);
		}
		for(i=0;i<loop_no;i++)
		{
			sprintf(cbuf,"q%d",i+1);
			pnames[i+in_prt+out_prt+1]=NewAtom(cbuf,2);
		}
	}
	for(i=1;i<=in_prt+out_prt;i++) pmass[i]=OPR_MLT;
	
	if(db[0]) 
		printf("------------------ Debug output for diagram %d  -----------------\n",
				diag_no);
	
	for(l=diag;l;l=ListTail(l))
	{
		Term a2;
		int pno;
		List l3,l4,l6,l7,p1,p2,p3;
		
		l3=CompoundArgN(ListFirst(l),3);
		l4=CompoundArgN(ListFirst(l),4);
		l6=CompoundArgN(ListFirst(l),6);
		l7=CompoundArgN(ListFirst(l),7);
		a2=CompoundArgN(ListFirst(l),5);

		if(db[1])
		{
			vno++;
			printf("\n--------------------- Vertex %d --------------------------\n",vno);
			printf("Particles list:       ");
			WriteTerm(CompoundArg1(ListFirst(l)));puts("");
			printf("Their momenta:        ");WriteTerm(l3);puts("");
			printf("Their vector indices: ");WriteTerm(l4);puts("");
			printf("Pos of prt in list:   ");WriteTerm(l6);puts("");
			printf("Polarization/helicity:");WriteTerm(l7);puts("");
			printf("Vertex:\n");
			printf("prts\t");WriteTerm(CompoundArg1(a2));puts("");
			printf("mterms:");DumpList(CompoundArgN(a2,5));puts("");
		}
		
		
		for(p1=CompoundArg1(ListFirst(l)),p2=CompoundArg2(ListFirst(l));
				p1;p1=ListTail(p1),p2=ListTail(p2))
			if(is_integer(ListFirst(p2)))
				{
					Atom p;
					int i;
					p=ListFirst(p1);
					i=IntegerValue(ListFirst(p2));
					if(i>200) i-=200-in_prt;
					if(i>100) i-=100;
					p=GetAtomProperty(p,PROP_TYPE);
					if(!is_compound(p) || CompoundName(p)!=OPR_PARTICLE)
					{
						puts("Unphysical particle in in/out state");
						exit(0);
					}
					pmass[i]=CompoundArgN(p,5);
				}
					
		
		pno=0;
		ci=NewList();
		for(p1=CompoundArg1(a2);p1;p1=ListTail(p1))
		{
			List vind;
			Atom oi;
			Term ih;
			pno++;
			vind=ListNth(l6,pno);
			oi=ListNth(l7,IntegerValue(vind));
			vind=ListNth(l4,IntegerValue(vind));
			ih=CompoundArg2(ListFirst(p1));
			if(CompoundName(ih)==OPR_VECTOR)
			{
				if(ListLength(vind)!=1)
				{
					puts("Internal error (buvf)");
					exit(0);
				}
				if(oi)
					ChangeList(vind,oi);
				ci=AppendLast(ci,MakeCompound2(
					OPR_DIV,ListFirst(CompoundArg1(ih)),ListFirst(vind)));
			}
			else if(CompoundName(ih)==OPR_TENSOR)
			{
				if(ListLength(vind)!=2)
				{
					puts("Internal error (butf)");
					exit(0);
				}
				if(oi)
					puts("Internal error (tpio)");
				ci=AppendLast(ci,MakeCompound2(OPR_DIV,
						ListFirst(CompoundArg1(ih)),ListFirst(vind)));
				ci=AppendLast(ci,MakeCompound2(OPR_DIV,
						ListNth(CompoundArg1(ih),2),ListNth(vind,2)));
			}
			else if(CompoundName(ih)==OPR_SPINOR)
			{
				int j;
				if(oi==0)
					oi=NewLabel();
				ci=AppendLast(ci,MakeCompound2(OPR_DIV,
						ListFirst(CompoundArg1(ih)),oi));
				j=IntegerValue(ListNth(l6,pno));
				vind=l4;
				for(j--;j;j--)
					vind=ListTail(vind);
				ChangeList(vind,oi);
				
			}
		}
		
		for(p1=CompoundArgN(a2,5);p1;p1=ListTail(p1))
		for(p2=CompoundArgN(ListFirst(p1),3);p2;p2=ListTail(p2))
		{
			for(p3=CompoundArg2(ListFirst(p2));p3;p3=ListTail(p3))
					ChangeList(p3,lu_up_i(&ci,ListFirst(p3)));
			if(CompoundName(ListFirst(p2))==A_MOMENT)
			{
				int j;
				j=IntegerValue(CompoundArg1(ListFirst(p2)));
				j=IntegerValue(ListNth(l6,j));
				SetCompoundArg(ListFirst(p2),1,CopyTerm(
						ListNth(l3,j)));
			}
		}
		p1=ConsumeCompoundArg(a2,5);
		FreeAtomic(ConsumeCompoundArg(a2,1));
/*		if(ListLength(p1)==1 && CompoundArg1(ListFirst(p1))==NewInteger(1)
				&& CompoundArg2(ListFirst(p1))==0 
				&& CompoundArgN(ListFirst(p1),3)==0)
		{
			if(db[2])
				puts("Skipping empty vertex");
		}
		else*/
			
			ee=AppendLast(ee,p1);
		
		if(db[2])
		{
			printf("Old index -> new index translation:");WriteTerm(ci);puts("");
			printf("NewVert:");DumpList(p1);
		}
		FreeAtomic(ci);
			
	}
	
	
	vno=0;
	for(l=diag;l;l=ListTail(l))
	{
		List l1,l2,l3,l4,p1,p2;
		l1=CompoundArgN(ListFirst(l),1);
		l2=CompoundArgN(ListFirst(l),2);
		l3=CompoundArgN(ListFirst(l),3);
		l4=CompoundArgN(ListFirst(l),4);
		vno++;
		pno=0;
		for(;l1;)
		{
			Atom pa;
			int vno1, pno1, spin, spec;
			List mom;
			
			pno++;
			if(is_integer(ListFirst(l2)))
				goto cnt;
			
			vno1=IntegerValue(CompoundArg1(ListFirst(l2)));
			pno1=IntegerValue(CompoundArg2(ListFirst(l2)));
			if(vno1<vno || (vno1==vno && pno1<pno))
				goto cnt;
			
			if(db[2])
				printf("Line v%dp%d -> v%dp%d: ",vno,pno,vno1,pno1);
			
			pa=ListFirst(l1);
			pa=GetAtomProperty(pa,PROP_TYPE);
			if(!is_compound(pa))
			{
				puts("Internal error (bups)");
				exit(0);
			}
			spec=0;
			if(CompoundName(pa)==OPR_PARTICLE)
			{
				spin=IntegerValue(CompoundArgN(pa,4));
				if(spin==1 && ListFirst(l1)==CompoundArg2(pa))
					spec=1;
				if((spin==0 || spin==2) && CompoundArgN(pa,7)==OPR_MLT)
					spec=1;
				if(spin==2 && CompoundArgN(pa,7)==0)
					spec=2;
			}
			else
			{
				puts("Internal error (bupx)");
				exit(0);
			}
			 
			mom=CopyTerm(ListFirst(l3));
			
			{  /* build propagator */
				Term i;
				i=MakeCompound(A_I,3);
				if(spin==1 || spec!=1)
					SetCompoundArg(i,1,mom_square(mom));
				SetCompoundArg(i,2,CompoundArgN(pa,5));
				SetCompoundArg(i,3,CompoundArgN(pa,6));
				props=AppendLast(props,i);
				if(db[2])
					printf(" den="),WriteTerm(i),printf(", ");
			}
			
			if(spin==1)
			{
				Term m1;
				Term la1, la2, la3;
				p2=NewList();
				
				la1=ListFirst(l4);
				la2=ListNth(diag,vno1);
				la2=CompoundArgN(la2,4);
				la2=ListNth(la2,pno1);
				la3=NewLabel();
				
				if(spec)
					for(p1=mom;p1;p1=ListTail(p1))
						ChangeList(p1,NewInteger(-IntegerValue(ListFirst(p1))));
				m1=MakeCompound(A_MTERM,3);
				SetCompoundArg(m1,1,NewInteger(1));
				SetCompoundArg(m1,3,MakeList2(
						MakeCompound2(OPR_SPECIAL,A_GAMMA,
						MakeList3(spec?la2:la1,spec?la1:la2,la3)),
						MakeCompound2(A_MOMENT,mom,AppendLast(0,la3))));
				p2=AppendLast(p2,m1);
				if(CompoundArgN(pa,5))
				{
					m1=MakeCompound(A_MTERM,3);
					SetCompoundArg(m1,1,NewInteger(1));
					SetCompoundArg(m1,2,AppendLast(0,
						MakeCompound2(OPR_POW,CompoundArgN(pa,5),NewInteger(1))));
					SetCompoundArg(m1,3,AppendLast(0,MakeCompound2(OPR_SPECIAL,
							A_DELTA,MakeList2(la1,la2))));
					p2=AppendLast(p2,m1);
				}
				ee=AppendLast(ee,p2);
				if(db[2])
					printf("spinor numerator:\n"),DumpList(p2);
			}
			if(spin==2)
			{
				Term m1,ms;
				Term la1, la2;
				p2=NewList();
				ms=CompoundArgN(pa,5);
				
				la1=ListFirst(ListFirst(l4));
				la2=ListNth(diag,vno1);
				la2=CompoundArgN(la2,4);
				la2=ListFirst(ListNth(la2,pno1));
				
				m1=MakeCompound(A_MTERM,3);
				SetCompoundArg(m1,1,NewInteger(1));
				if(ms && spec==2)
				{
					Term i;
					SetCompoundArg(m1,2,AppendLast(0,
						MakeCompound2(OPR_POW,ms,NewInteger(2))));
					i=MakeCompound3(A_I,0,ms,0);
					props=AppendLast(props,i);
				}
				SetCompoundArg(m1,3,AppendLast(0,MakeCompound2(OPR_SPECIAL,
						A_DELTA,MakeList2(la1,la2))));
				p2=AppendLast(p2,m1);
				
				if(ms && spec==2)
				{
					m1=MakeCompound(A_MTERM,3);
					SetCompoundArg(m1,1,NewInteger(1));
					SetCompoundArg(m1,3,MakeList2(
						MakeCompound2(A_MOMENT,CopyTerm(mom),AppendLast(0,la1)),
						MakeCompound2(A_MOMENT,mom,AppendLast(0,la1))));
					p2=AppendLast(p2,m1);
				}
				else
					FreeAtomic(mom);
				ee=AppendLast(ee,p2);
				if(db[2])
					printf(" vector numerator:\n"),DumpList(p2);
			}
			if(spin==0)
			{
				FreeAtomic(mom);
				if(db[2])
					printf("scalar numerator =1.\n");
			}
				
			
		cnt:l1=ListTail(l1);
			l2=ListTail(l2);
			l3=ListTail(l3);
			l4=ListTail(l4);
		}
	}
	
	for(i=1;i<=in_prt+out_prt;i++)
		if(pmass[i]==OPR_MLT)
		{
			printf("Particle %d not found\n",i);
			exit(0);
		}
	
	ee=ConcatList(ee,add_flines());	
	
	if(db[3])
	{
		puts("product of polynoms after indices substitution in vertices & propagators:");
		DumpList(ee);
	}
		
		
	
	{
		List p1,p2;
		int i,xno;
		
		for(i=0;i<HASH_SZ;i++) hash[i]=0;
		
		p2=ListFirst(ee);
		for(p1=ListTail(ee);p1;p1=ListTail(p1))
			p2=mult_l(p2,ListFirst(p1));
		RemoveList(ee);
		ee=p2;
		
		for(p1=ee;p1;p1=ListTail(p1))
			red_dlt(ListFirst(p1));
		
				
		for(p1=ee;p1;p1=ListTail(p1))
			mk_trace(ListFirst(p1));
		
		p2=ee;
		ee=NewList();
		for(p1=p2;p1;p1=ListTail(p1))
			if(CompoundArg1(ListFirst(p1))==NewInteger(0))
				FreeAtomic(ListFirst(p1));
			else
				ee=AppendLast(ee,ListFirst(p1));
		RemoveList(p2);
		
		
		
		if(db[4])
		{
			printf("The expression before spur calculations:\n");
			for(p1=ee;p1;p1=ListTail(p1))
			{
				printf("\t");WriteTerm(ListFirst(p1));puts("");
				for(p2=CompoundArgN(ListFirst(p1),3);p2;p2=ListTail(p2))
					if(CompoundName(ListFirst(p2))==A_GAMMA)
						printf("\t\t"),WriteTerm(ListFirst(p2)),puts("");
			}
			printf("The above is expression (%d monoms) before spur calculations.\n",
					ListLength(ee));
			fflush(stdout);
			fprintf(stderr,"\n%d monoms before spur calculation\n",ListLength(ee));
		}
		
		p2=ee;
		ee=NewList();
		vno=0; pno=0; xno=0;
		for(p1=p2;p1;p1=ListTail(p1))
		{
			List q1,q2;
			
			ee=mt_2_lmt(ListFirst(p1));
			vno++;
			q2=ee;
			ee=NewList();
			for(q1=q2;q1;q1=ListTail(q1))
			{
				Term m2;
				List r1,r2;
				m2=ListFirst(q1);
				
				if(db[4])
					fprintf(stderr,"%5d -> %5d of %d\r",vno,pno,xno),
						fflush(stderr);
				
				red_dlt(m2);
				r2=rm_e2(m2);
				for(r1=r2;r1;r1=ListTail(r1))
				{
					m2=ListFirst(r1);
					can_m2(m2);
					if(CompoundArg1(m2)==NewInteger(0))
					{
						FreeAtomic(m2);
						continue;
					}
					
					
					i=((can_val(m2))%HASH_SZ);
				
					hash[i]=add_can(hash[i],m2);
				
					pno+=a_c_r;
					xno++;
				}
				RemoveList(r2);
			}
			RemoveList(q2);
		}
		
		
		if(db[4])
			fprintf(stderr,"           \n");

		
		
	for(i=0;i<HASH_SZ;i++)
	{
		ee=ConcatList(hash[i],ee);
	}
	
/*	for(p1=props;p1;p1=ListTail(p1))
	{
		p2=CompoundArg1(ListFirst(p1));
		if(p2 && IntegerValue(ListFirst(p2))<0)
			for(;p2;p2=ListTail(p2))
				ChangeList(p2,NewInteger(-IntegerValue(ListFirst(p2))));
	}
*/		
	}
	
	
	if(db[6])
	{
		printf("After combining similar terms: %d monoms.\n",pno);
		DumpList(ee);
	}
	
	td_prop=props;
	td_num=ee;
	
	return 1;
}

