#include <string.h>
#include <stdlib.h>
#include "terms.h"

#define DATA_DBG

static char *abuffers[256];
static int  abuffill[256], acount=0, stacount=0, atscount=0;

void InitAtoms1(void);

void InitAtoms(void)
	{
	int i;
	for(i=0;i<256;i++)
		{
		abuffill[i]=0;
		abuffers[i]=NULL;
		}
	InitAtoms1();
	}
		

Atom NewAtom(char *s, int len)
	{
	int i,j,ret;
	if(len==0) len=strlen(s);
	
	/*   searching..  */
	i=0;
	stacount++;
	while(abuffers[i]!=NULL)
		{
		char *abuff;
		abuff=abuffers[i];
		j=0;
		while(j<abuffill[i])
			{
			
			int k=0;
			j+=sizeof(List);
			while(s[k]==abuff[j+k] && k<len) k++;
			if(k==len && abuff[j+k]==0)
				return j-sizeof(List)+i*0x10000+0x01000000;
			j+=k;
			while(abuff[j]!=0) j++; j++;
			while(j%4)  j++;
			/*
			if(strcmp(s,abuffers[i]+j)==0)
				return j+i*0x10000+0x01000000;
			j+=strlen(abuffers[i]+j)+1;
			*/
			}
		i++;
		}
	/*  inserting ... */
	acount++;
	i=0;
	while(i<256 && abuffers[i]!=NULL && abuffill[i]+len+sizeof(List)>0xffff)
		i++;
	if(i==256)
		{  puts("Internal error (too much atoms or memory lack)."); exit(0); }
	if(abuffers[i]==NULL)
		{
		abuffers[i]=(char *)malloc(0x10000);
		if(abuffers[i]==NULL)
			{  puts("Internal error (memory lack for atoms)."); exit(0); }
		}
	{ List *tmp; tmp=(List *)(abuffers[i]+abuffill[i]); *tmp=NewList(); }
	strncpy(abuffers[i]+abuffill[i]+sizeof(List),s,len);
	*(abuffers[i]+abuffill[i]+len+sizeof(List))=0;
	ret=abuffill[i];
	abuffill[i]+=len+1+sizeof(List);
	while(abuffill[i]%4) abuffill[i]++;
	return ret+i*0x10000+0x01000000;
	
	}
	
char *AtomValue(Atom a)
	{
	int  bno,bpos;
	char mb[2];
	bno=a&0xff0000;
	bno/=0x10000;
	bpos=a&0xffff;
	if(abuffers[bno]==NULL)
		{
		printf("Internal error (illegal atom '");
		if(!is_atom(a))
			WriteTerm(a);
		else
			printf("%lx",a);
		printf("').\n");
		return "??";
		}
	atscount++;
	return abuffers[bno]+bpos+sizeof(List);
	}

void SetAtomProperty(Atom a, Atom type, Term value)
     {
     int  bno,bpos;
     List *lp,ll;
     Term tt;
     bno=a&0xff0000;
     bno/=0x10000;
     bpos=a&0xffff;
     if(abuffers[bno]==NULL)
	     {  puts("Internal error (illegal atom)."); exit(0); }
     lp=(List *)(abuffers[bno]+bpos);
     ll=*lp;
     while(!is_empty_list(ll))
         {
         tt=ListFirst(ll);
         if(CompoundName(tt)==type)
             {
             Term kk;
             kk=ConsumeCompoundArg(tt,1);
             FreeAtomic(kk);
             SetCompoundArg(tt,1,value);
             return;
             }
         ll=ListTail(ll);
         }
     tt=MakeCompound(type,1);
     SetCompoundArg(tt,1,value);
     *lp=AppendLast(*lp,tt);
     }

Term GetAtomProperty(Atom a, Atom type)
     {
     int  bno,bpos;
     List *lp,ll;
     Term tt;
     if(!is_atom(a)) WriteTerm(a),puts("!!!!!!!");
     bno=a&0xff0000;
     bno/=0x10000;
     bpos=a&0xffff;
     if(abuffers[bno]==NULL)
	     {  puts("Internal error (illegal atom) (GetAtomProp)."); exit(0); }
     lp=(List *)(abuffers[bno]+bpos);
     ll=*lp;
     while(!is_empty_list(ll))
         {
         tt=ListFirst(ll);
         if(CompoundName(tt)==type)
             return CompoundArg1(tt);
         ll=ListTail(ll);
         }
     return (Atom)0;
     }

void RemoveAtomProperty(Atom a, Atom type)
     {
     int  bno,bpos;
     List *lp,ll;
     Term tt;
     bno=a&0xff0000;
     bno/=0x10000;
     bpos=a&0xffff;
     if(abuffers[bno]==NULL)
	     {  puts("Internal error (illegal atom)."); exit(0); }
     lp=(List *)(abuffers[bno]+bpos);
     ll=*lp;
     while(!is_empty_list(ll))
         {
         tt=ListFirst(ll);
         if(CompoundName(tt)==type)
             {
             *lp=CutFromList(*lp,ll);
             return;
             }
         ll=ListTail(ll);
         }
     return;
     }
     
Term SetProperty(Term t, Term ind)
	{
	if(!is_compound(t) || CompoundArity(t)!=3 ||
		!is_atom(CompoundArg1(t)) ||
		!is_atom(CompoundArg2(t)))
		{
		ErrorInfo(390);
		puts("bad arguments in SetProperty statement");
		}
	SetAtomProperty(CompoundArg1(t),CompoundArg2(t),
		ConsumeCompoundArg(t,3));
	FreeAtomic(t);
	return 0;
	}

Term GetProperties(Term t, Term ind)
	{
	int  bno,bpos;
	Atom a;
     List *lp;
     a=ConsumeCompoundArg(t,1);
     FreeAtomic(t);
     if(!is_atom(a))
     	return 0;
     bno=a&0xff0000;
     bno/=0x10000;
     bpos=a&0xffff;
     if(abuffers[bno]==NULL)
	     {  puts("Internal error (illegal atom)."); exit(0); }
     lp=(List *)(abuffers[bno]+bpos);
	return CopyTerm(*lp);
	}

union fpoint
	{
	double d;
	struct 	{
		union fpoint *next;
		Float f;
		} p;
	};
	

	
static union fpoint *f_next_free=NULL;	
static union fpoint *fbuffers[256];
static int f_blocks=0, f_dtf=0, f_ftd=0;

	
	
Float NewFloat(double d)
	{
	union fpoint *p;
	Float f;
	if(f_next_free==NULL)
		{
		int i;
		if(f_blocks==256)
			{  puts("Internal error (too much floats or memory lack)."); exit(0); }
		p=fbuffers[f_blocks]=(union fpoint*)malloc(sizeof(union fpoint)*1000);
		if(p==NULL)
			{  puts("Internal error (lack space for float)."); exit(0); }
		for(i=0;i<1000;i++)
			{
			p[i].p.next=f_next_free;
			f_next_free=p+i;
			p[i].p.f=0x7f000000+f_blocks*0x10000+i;
			}
		f_blocks++;
		}
	p=f_next_free;
	f_next_free=f_next_free->p.next;
	f=p->p.f;
	p->d=d;
	f_dtf++;
	return f;
	}
	
double FloatValue(Float f)
	{
	union fpoint *p;
	int bno,bpos;
	bno=f&0xff0000;
	bno/=0x10000;
	bpos=f&0xffff;
	p=fbuffers[bno]+bpos;
	return p->d;
	}
	
	
Integer NewInteger(long l)
	{
	Integer i;
	i=l-1073741824;
	if(i>=0)
		{  puts("Internal error (integer out of range)."); exit(0); }
	return i;
	}

long IntegerValue(Integer i)
	{
	return i+1073741824;
	}


Functor NewFunctor(Atom name, int arity)
	{
	if(arity<1 || arity >32)
		{  puts("Internal error (arity out of range)."); exit(0); }
	return (name&0xffffff) + (arity+1)*0x1000000;
	}
	
Atom 	FunctorName(Functor f)
	{
	return (f & 0xffffff) + 0x1000000;
	}
	
int 	FunctorArity(Functor f)
	{
	return (f/0x1000000)-1;
	}
	


union cpoint 
	{
	struct {
		Atomic a[3];
		Atomic next_a;
		union cpoint *next_p;
		} data;
	struct 	{
		union cpoint *next;
		Atomic this;
		} p;
	};
	

	
static union cpoint *c_next_free=NULL;	
static union cpoint *cbuffers[256];
static int c_blocks=0, c_tall=0, c_tfree=0;

static void f_compound(Compound c)
	{
	union cpoint *p;
	int bno,bpos;
	bno=c&0xff0000;
	bno/=0x10000;
	bpos=c&0xffff;
#ifdef DATA_DBG
	if(bno<0 || bno >c_blocks)
		{
		printf("cfree: block %d not exists\n",bno);
		abort();
		}
#endif
	p=cbuffers[bno]+bpos;
	p->p.this=c;
	p->p.next=c_next_free;
#ifdef DATA_DBG
	if(p->data.next_a==1)
		{
		puts("cfree: twice freed cell");
		abort();
		}
	p->data.next_a=1;
#endif
	p->data.next_a=1;
	c_next_free=p;
	c_tfree++;
	return;
	}
	
	
static union cpoint *a_compound(Compound *cco)
	{
	union cpoint *p;
	Compound co;
	if(c_next_free==NULL)
		{
		int i;
		if(c_blocks==256)
			{  puts("Internal error (too much terms)."); exit(0); }
		i=sizeof(union cpoint)*65500;
		p=cbuffers[c_blocks]=(union cpoint*)malloc(i);
		if(p==NULL)
			{  puts("Internal error (lack space for terms)."); exit(0); }
		for(i=0;i<65500;i++)
			{
			p[i].p.next=c_next_free;
			c_next_free=p+i;
			p[i].p.this=0x7e000000+c_blocks*0x10000+i;
			}
		c_blocks++;
		}
	p=c_next_free;
	c_next_free=c_next_free->p.next;
	co=p->p.this;
	*cco=co;
	c_tall++;
	return p;
	}
	
Compound  NewCompound(Functor fu)
	{
	union cpoint *p;
	Compound c;
	int arity;
	
	arity=FunctorArity(fu);
	p=a_compound(&c);
	p->data.a[0]=fu;
	p->data.a[1]=p->data.a[2]=0;
	p->data.next_a=0; p->data.next_p=NULL;
	arity-=2;
	while(arity>0)
		{
		Compound c1;
		union cpoint *p1;
		p1=a_compound(&c1);
		p->data.next_a=c1;
		p->data.next_p=p1;
		p1->data.a[0]=p1->data.a[1]=p1->data.a[2]=p1->data.next_a=0;
		p1->data.next_p=NULL;
		p=p1;
		arity-=3;
		}
	return c;
	}

	
	
	
Functor CompoundFunctor(Compound c)
	{
	union cpoint *p;
	int bno,bpos;
	bno=c&0xff0000;
	bno/=0x10000;
	bpos=c&0xffff;
	p=cbuffers[bno]+bpos;
	return p->data.a[0];
	}
	
Term CompoundArg1(Compound c)
	{
	union cpoint *p;
	int bno,bpos;
	bno=c&0xff0000;
	bno/=0x10000;
	bpos=c&0xffff;
	p=cbuffers[bno]+bpos;
	return p->data.a[1];
	}
	
Term CompoundArg2(Compound c)
	{
	union cpoint *p;
	int bno,bpos;
	bno=c&0xff0000;
	bno/=0x10000;
	bpos=c&0xffff;
	p=cbuffers[bno]+bpos;
	return p->data.a[2];
	}
	
Term CompoundArgN(Compound c, int arg)
	{
	union cpoint *p;
	int bno,bpos;
	bno=c&0xff0000;
	bno/=0x10000;
	bpos=c&0xffff;
	p=cbuffers[bno]+bpos;
	while(arg>2)
		{ p=p->data.next_p; arg-=3; }
	return p->data.a[arg];
	}
	
Term ConsumeCompoundArg(Compound c, int arg)
	{
	union cpoint *p;
	int bno,bpos;
	Term ret;
	bno=c&0xff0000;
	bno/=0x10000;
	bpos=c&0xffff;
	p=cbuffers[bno]+bpos;

#ifdef DATA_DBG
	if(bno<0 || bno >c_blocks)
		{
		puts("CCA: block %d not exists\n");
		abort();
		}
	if(p->data.next_a==1)
		{
		puts("CCA: freed cell");
		abort();
		}
#endif

	
	while(arg>2)
		{ p=p->data.next_p; arg-=3; }
	ret=p->data.a[arg];
	p->data.a[arg]=0;
	return ret;
	}	

	
void SetCompoundArg(Compound c, int arg, Term t)
	{
	union cpoint *p;
	int bno,bpos;
	bno=c&0xff0000;
	bno/=0x10000;
	bpos=c&0xffff;
	p=cbuffers[bno]+bpos;

#ifdef DATA_DBG
	if(bno<0 || bno >c_blocks)
		{
		puts("SCA: block %d not exists\n");
		abort();
		}
	if(p->data.next_a==1)
		{
		puts("SCA: freed cell");
		abort();
		}
#endif

	
	while(arg>2)
		{ p=p->data.next_p; arg-=3; }
	/*if(p->data.a[arg]!=0) FreeAtomic(p->data.a[arg]);*/
	p->data.a[arg]=t;
	}
	

Compound MakeCompound(Atom name, int arity)
	{
	return NewCompound(NewFunctor(name,arity));
	}

Compound MakeCompound1(Atom name, Term arg1)
    {
    Term tt;
    tt=NewCompound(NewFunctor(name,1));
    SetCompoundArg(tt,1,arg1);
    return tt;
    }

Compound MakeCompound2(Atom name, Term arg1, Term arg2)
    {
    Term tt;
    tt=NewCompound(NewFunctor(name,2));
    SetCompoundArg(tt,1,arg1);
    SetCompoundArg(tt,2,arg2);
    return tt;
    }

Compound MakeCompound3(Atom name, Term arg1, Term arg2, Term arg3)
    {
    Term tt;
    tt=NewCompound(NewFunctor(name,3));
    SetCompoundArg(tt,1,arg1);
    SetCompoundArg(tt,2,arg2);
    SetCompoundArg(tt,3,arg3);
    return tt;
    }

	
Atom CompoundName(Compound c)
	{
	return FunctorName(CompoundFunctor(c));
	}
	
int CompoundArity(Compound c)
	{
	return FunctorArity(CompoundFunctor(c));
	}
	 
	

void FreeCompound(Compound c)
	{
	union cpoint *p,*p1;
	int bno,bpos,arity;
	Compound c1;
	bno=c&0xff0000;
	bno/=0x10000;
	bpos=c&0xffff;
	p=cbuffers[bno]+bpos;
	arity=FunctorArity(p->data.a[0]);
	do
		{
		p1=p->data.next_p;
		c1=p->data.next_a;
		FreeAtomic(p->data.a[0]);
		FreeAtomic(p->data.a[1]);
		FreeAtomic(p->data.a[2]);
		f_compound(c);
		p=p1;
		c=c1;
		}   while(p!=NULL && c!=0);
	}
		
	
static int lbl_count = 0;
	
Atomic NewLabel(void)
	{
	return ++lbl_count+0x7c000000;
	}
	
int   LabelValue(Atomic l)
	{
	return l-0x7c000000;
	}
	


void FreeAtomic(Atomic a)
	{
	long type;
	if(a<0) return;
	type = a&0xff000000;
	type = type/0x1000000;
	if(type==127)
		{
		union fpoint *p;
		int bno,bpos;
		bno=a&0xff0000;
		bno/=0x10000;
		bpos=a&0xffff;
		p=fbuffers[bno]+bpos;
		p->p.f=a;
		p->p.next=f_next_free;
		f_next_free=p;
		f_ftd++;
		return;
		}
	if(type==126)
		{
		FreeCompound(a);
		return;
		}
	if(type==125)
		{
		FreeList(a);
		return;
		}
		
	}

Term CopyTerm(Term t)
     {
     char ty;
     ty=AtomicType(t);
     switch(ty)
         {
         case 'i':
         case 'a':
         case 'e':
         case '?':
         case 'u':
         case 'L':
              return t;
         case 'f':
              {
              double f;
              f=FloatValue(t);
              return NewFloat(f);
              }
         case 'c':
              {
              Term tt;
              int i,ar;
              ar=CompoundArity(t);
              tt=MakeCompound(CompoundName(t),ar);
              for(i=1;i<=ar;i++)
                  SetCompoundArg(tt,i,CopyTerm(CompoundArgN(t,i)));
              return tt;
              }
         case 'l':
              {
              List li,ll;
              li=NewList();
              ll=t;
              while(!is_empty_list(ll))
                  {
                  li=AppendLast(li,CopyTerm(ListFirst(ll)));
                  ll=ListTail(ll);
                  }
              return li;
              }
         }
     return 0;
     }



			
int is_atomic(Atomic a)
	{
	long type;
	if(a<0) return 1;
	type = a&0xff000000;
	type = type/0x1000000;
	if(type==1 || type==127 || type==124) return 1;
	return 0;
	}
	
int is_float(Atomic a)
	{
	return (a&0xff000000)==0x7f000000;
	}
	
int is_integer(Atomic a)
	{
	return a<0;
	}
	
int is_atom(Atomic a)
	{
	return (a&0xff000000)==0x01000000;
	}
	
int is_functor(Atomic a)
	{
	int b;
	b=a/0x1000000;
	return (b>1 && b<34);
	}
	
int is_compound(Term a)
	{
	return a/0x1000000 == 126;
	}
	
int is_list(Term a)
	{
	return a/0x1000000 == 125;
	}
	
int is_label(Term a)
	{
	return a/0x1000000 == 124;
	}
	
char AtomicType(Atomic a)
	{
	long type;
	if(a<0) return 'i';
	type = a&0xff000000;
	type = type/0x1000000;
	if(type==1)
		return 'a';
	if(type==127)	/* 0xff */
		return 'f';
	if(type==126)   /* 0xfe */
		return 'c';
	if(type==125)  /*  0xfd */ 
		return 'l';
	if(type==124)  /*  0xfc */
		return 'L';
	if(type>1 && type<34)
		return 'u';
	if(a==0)
		return 'e';
	return '?';
	}
	
		
void AtomStatistics(void)
	{
	printf("Atoms: %d       , %d a->s  , %d s->a\n",acount,atscount,stacount);
	printf("Terms: %d blocks, %d allocs, %d frees ( %d remain) \n",
		c_blocks,c_tall,c_tfree,c_tall-c_tfree);
	printf("Float: %d blocks, %d allocs, %d frees\n",f_blocks,f_dtf,f_ftd);
	printf("Labels:          %d allocs\n",lbl_count);
	}

void AtomStat1(void)
	{
	printf("%d atoms, ",acount);
	printf("%d terms (%d blocks), ",c_tall-c_tfree,c_blocks);
	}
	
int EqualTerms(Term t1, Term t2)
	{
	if(t1==t2)
		return 1;
	if(is_compound(t1) && is_compound(t2) && 
		CompoundFunctor(t1) == CompoundFunctor(t2))
		{
		int i,a;
		a=CompoundArity(t1);
		for(i=1;i<=a;i++)	
			if(!EqualTerms(CompoundArgN(t1,i),CompoundArgN(t2,i)))
				return 0;
		return 1;
		}
	if(is_list(t1) && is_list(t2) && ListLength(t1)==ListLength(t2))
		{
		List l1,l2;
		l1=t1;
		l2=t2;
		while(!is_empty_list(l1))
			{
			if(!EqualTerms(ListFirst(l1),ListFirst(l2)))
				return 0;
			l1=ListTail(l1);
			l2=ListTail(l2);
			}
		return 1;
		}
	return 0;
	}
			
			
