#include <stdio.h>
#include <stdlib.h>
#include "terms.h"
#include "ga.h"

extern Atom pmass[16];
extern int db[10];

int aux_vec_no=0;

List ferm_a_v_d=0, ferm_a_v_e=0, ferm_a_v_f=0;

static int has_add_v=0;

List add_flines(void)
	{

	List l,ee=0;
	Term p3, e3;
	aux_vec_no=0;
	
	for(l=flines;l;l=ListTail(l))
	{
		List l1,l2;
		Term b,e,m1,m2,la3,la4,la1,la2,p1,p2,e1,e2,la5,la6;
		char cbuf[16];
		l1=ListFirst(l);
		b=ListFirst(l1);
		while(ListTail(l1)) l1=ListTail(l1);
		e=ListFirst(l1);
		
		la1=CompoundArg2(CompoundArg2(b));
		p1=CompoundArg1(CompoundArg2(b));
		b=IntegerValue(CompoundArg1(b));
		if(b>200) b-=200-in_prt;
		if(b>100) b-=100;
		m1=pmass[b];
		la2=CompoundArg2(CompoundArg2(e));
		p2=CompoundArg1(CompoundArg2(e));
		e=IntegerValue(CompoundArg1(e));
		if(e>200) e-=200-in_prt;
		if(e>100) e-=100;
		m2=pmass[e];
		
		la3=NewLabel();
		la4=NewLabel();
		
		sprintf(cbuf,"p%d",in_prt+out_prt+loop_no+1);
		p3=NewAtom(cbuf,0);
		cbuf[0]='e';
		e3=NewAtom(cbuf,0);
		aux_vec_no=in_prt+out_prt+loop_no+1;
		
		sprintf(cbuf,"p%d",(int)b);
		p1=NewAtom(cbuf,0);
		cbuf[0]='e';
		e1=NewAtom(cbuf,0);
		sprintf(cbuf,"p%d",(int)e);
		p2=NewAtom(cbuf,0);
		cbuf[0]='e';
		e2=NewAtom(cbuf,0);
		
		
		if(has_add_v==0)
		{
			ferm_a_v_d=AppendLast(ferm_a_v_d,
				MakeList4(NewInteger(1),p1,e1,pmass[b]));
			ferm_a_v_d=AppendLast(ferm_a_v_d,
				MakeList4(NewInteger(1),p2,e2,pmass[e]));
		}
		
		if(db[3])
		{
			printf("Fline ");WriteTerm(ListFirst(l));
			printf("\nStart: label ");WriteTerm(la1);
			printf(", mom ");WriteTerm(p1);
			printf(", mass "); m1?WriteTerm(m1):printf("0");
			printf(", %s state\n",b>in_prt?"out":"in");
			printf("End: label ");WriteTerm(la2);
			printf(", mom ");WriteTerm(p2);
			printf(", mass "); m2?WriteTerm(m2):printf("0");
			printf(", %s state.\n",e>in_prt?"out":"in");
			printf("r and l vectors: ");WriteTerm(p3);
			printf(" ");WriteTerm(e3);puts("");
		}
		
		l1=NewList();
		
		l2=NewList();
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la2,la3,p2)));
		l1=AppendLast(l1,
				MakeCompound3(A_MTERM,NewInteger(e>in_prt?1:-1),0,l2));
		
		if(m2)
		{
		l2=NewList();
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_DELTA,
				MakeList2(la2,la3)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(1),
				AppendLast(0,
				MakeCompound2(OPR_POW,m2,NewInteger(e>in_prt?-1:1))),l2));
		}
			
		l2=NewList();
		la5=NewLabel();
		la6=NewLabel();
		
		if(m2)
		{
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la2,la5,p2)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA5,
				MakeList2(la5,la6)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la6,la3,e2)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(1),
				AppendLast(0,MakeCompound2(OPR_POW,la2,NewInteger(1))),l2));
		}
		else
		{
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la2,la5,p2)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA5,
				MakeList2(la5,la3)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(1),
				AppendLast(0,MakeCompound2(OPR_POW,la2,NewInteger(1))),l2));
		}
		
		if(m2)
		{
		l2=NewList();
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA5,
				MakeList2(la2,la5)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la5,la3,e2)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(e>in_prt?-1:1),
				MakeList2(MakeCompound2(OPR_POW,m2,NewInteger(1)),
						  MakeCompound2(OPR_POW,la2,NewInteger(1))),l2));
		}
		
		
		if(db[3])
		{
			printf("^P=");DumpList(l1);
		}
		ee=AppendLast(ee,l1);
		
		l1=NewList();
		
		l2=NewList();
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la3,la4,p3)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(1),0,l2));
		
		l2=NewList();
		la5=NewLabel();
		la6=NewLabel();
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la3,la5,p3)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA5,
				MakeList2(la5,la6)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la6,la4,e3)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(1),0,l2));
		
		if(db[3])
		{
			printf("^Z=");DumpList(l1);
		}
		ee=AppendLast(ee,l1);
		
		l1=NewList();
		
		l2=NewList();
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la4,la1,p1)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,
				NewInteger(b>in_prt?-1:1),0,l2));
		
		if(m1)
		{
		l2=NewList();
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_DELTA,
				MakeList2(la4,la1)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(b>in_prt?1:-1),
				AppendLast(0,MakeCompound2(OPR_POW,m1,NewInteger(1))),l2));
		}
		

		l2=NewList();
		la5=NewLabel();
		la6=NewLabel();
		if(m1)
		{
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la4,la5,p2)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA5,
				MakeList2(la5,la6)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la6,la1,e1)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(1),
				AppendLast(0,MakeCompound2(OPR_POW,la1,NewInteger(1))),l2));
		}
		else
		{
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la4,la5,p2)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA5,
				MakeList2(la5,la1)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(1),
				AppendLast(0,MakeCompound2(OPR_POW,la1,NewInteger(1))),l2));
		}
		
		if(m1)
		{
		l2=NewList();
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA5,
				MakeList2(la4,la5)));
		l2=AppendLast(l2,MakeCompound2(OPR_SPECIAL,A_GAMMA,
				MakeList3(la5,la1,e1)));
		l1=AppendLast(l1,MakeCompound3(A_MTERM,NewInteger(b>in_prt?1:-1),
				MakeList2(MakeCompound2(OPR_POW,m1,NewInteger(1)),
				          MakeCompound2(OPR_POW,la1,NewInteger(1))),l2));
		}

		
		if(db[3])
		{
			printf("^Q=");DumpList(l1);
		}
		ee=AppendLast(ee,l1);
	}
		
	if(flines && has_add_v==0)
	{
		has_add_v=1;
		ferm_a_v_d=AppendLast(ferm_a_v_d,MakeList4(NewInteger(2),
			p3,e3,0));
	}
	
	return ee;
}



static List ct_res;
static int ct_g5=0;
static Label ct_g5_l[4];


static int ct_in_eps(Label l)
{
	if(l==ct_g5_l[0])
		return 1;
	if(l==ct_g5_l[1])
		return 2;
	if(l==ct_g5_l[2])
		return 3;
	if(l==ct_g5_l[3])
		return 4;
	return 0;
}


static void ct_mkm(Label *la, int *pos, int no, int sign)
{
	Term m2;
	int i;
	List l;
	if(ct_g5)
		for(i=0;i<no;i+=2)
		{
			if(ct_in_eps(la[pos[i]-1]) && ct_in_eps(la[pos[i+1]-1]))
				return;
		}

	m2=MakeCompound(A_MTERM,3);
	SetCompoundArg(m2,1,NewInteger(4*sign));
	l=NewList();
	for(i=0;i<no;i+=2)
		l=AppendLast(l,MakeCompound2(OPR_SPECIAL,A_DELTA,
				MakeList2(la[pos[i]-1],la[pos[i+1]-1])));
	SetCompoundArg(m2,3,l);
	
	ct_res=AppendLast(ct_res,m2);
	
}

static void ct_mkco(Label *labs, int *pos, int ino, int first, int sign)
{
	int i,ts,tmp;
	if(first==ino-2)
	{
		ct_mkm(labs,pos,ino,sign);
		return;
	}
	ts=1;
	ct_mkco(labs,pos,ino,first+2,sign);
	for(i=first+2;i<ino;i++)
	{
		ts*=-1;
		tmp=pos[i];
		pos[i]=pos[first+1];
		pos[first+1]=tmp;
		ct_mkco(labs,pos,ino,first+2,sign*ts);
/*		tmp=pos[i];
		pos[i]=pos[first+1];
		pos[first+1]=tmp;*/
	}
	tmp=pos[first+1];
	for(i=first+1;i<ino-1;i++)
		pos[i]=pos[i+1];
	pos[ino-1]=tmp;
	if(ts<0)
	{
		puts("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		exit(0);
	}
}

static int ct_val(Term t)
{
	char *p;
	if(is_label(t))
	{
		register int r;
		r=ct_in_eps(t);
		if(r) return -r;
		return LabelValue(t)+100000;
	}
	p=AtomValue(t);
	return p[1]-'0'+100*p[0];
}

static int ct_sort(Term d1, Term d2)
{
	List l1, l2;
	Label a11,a12,a21,a22;
	l1=CompoundArg2(d1);
	l2=CompoundArg2(d2);
	a11=ListFirst(l1);
	a12=ListFirst(ListTail(l1));
	a21=ListFirst(l2);
	a22=ListFirst(ListTail(l2));
	if(ct_in_eps(a12) && ct_in_eps(a22))
		return ct_val(a11)-ct_val(a21);
	if(ct_in_eps(a12))
		return 1;
	if(ct_in_eps(a22))
		return -1;
	return ct_val(a11)*10000+ct_val(a12)
		-ct_val(a21)*10000+ct_val(a22);
}

static List ct_add_si(List l, Term m2)
{
	List l1;
	for(l1=l;l1;l1=ListTail(l1))
	{
		if(EqualTerms(CompoundArgN(m2,3),CompoundArgN(ListFirst(l1),3)))
		{
			int v;
			v=IntegerValue(CompoundArg1(m2))+
					IntegerValue(CompoundArg1(ListFirst(l1)));
			if(v)
				SetCompoundArg(ListFirst(l1),1,NewInteger(v));
			else
				l=CutFromList(l,l1);
			FreeAtomic(m2);
			return l;
		}
	}

	return AppendLast(l,m2);
}

List calc_tr(Term ga, int is_g5)
{
	List l;
	Label labs[128];
	int   pos[128];
	int   i,ino=0;
	ct_res=0;

	ct_g5=is_g5;
	
	if(db[5])
	{
		printf("Calculating spur, g5 %s: ",is_g5?"present":"absent");
		WriteTerm(ga);
		puts("; result:");
	}
	
	for(l=CompoundArg2(ga);l;l=ListTail(l))
		labs[ino++]=ListFirst(l);
	FreeAtomic(ga);
	
	if(is_g5)
	{
		ct_g5_l[0]=labs[0];
		ct_g5_l[1]=labs[1];
		ct_g5_l[2]=labs[2];
		ct_g5_l[3]=labs[3];
	}
/*	
	labs[4]=NewAtom("aa1",0);
	labs[5]=NewAtom("aa2",0);
	labs[6]=NewAtom("aa3",0);
	labs[7]=NewAtom("aa4",0);
*/
	for(i=1;i<=ino;i++)
		pos[i-1]=i;	
	
	ct_mkco(labs,pos,ino,0,1);
	
	if(db[5])
		DumpList(ct_res);
	
	if(is_g5)
	{
		List ct_res1;
		ct_res1=NewList();
		for(l=ct_res;l;l=ListTail(l))
		{
			List l1,l2,lh[4];
			int ivals[4];
			int j,s;
			l1=ConsumeCompoundArg(ListFirst(l),3);
			for(l2=l1;l2;l2=ListTail(l2))
			{
				List l3;
				Term a1,a2;
				l3=CompoundArg2(ListFirst(l2));
				a1=ListFirst(l3);
				a2=ListFirst(ListTail(l3));
				if(ct_val(a1)<ct_val(a2))
				{
					ChangeList(l3,a2);
					ChangeList(ListTail(l3),a1);
				}
			}
			l1=SortedList(l1,ct_sort);
			SetCompoundArg(ListFirst(l),3,l1);
			j=0;
			for(l2=l1;l2;l2=ListTail(l2))
			{
				List l3;
				for(l3=CompoundArg2(ListFirst(l2));l3;l3=ListTail(l3))
					if(ct_in_eps(ListFirst(l3)))
					{
						lh[j]=l3;
						ivals[j]=ct_in_eps(ListFirst(l3));
						j++;
					}
			}
			if(j!=4)
			{
				puts("Internal error (buctmk)");
				exit(0);
			}
			
			s=1;
			for(i=0;i<5;i++)
				for(j=0;j<3;j++)
				{
					if(ivals[j]>ivals[j+1])
					{
						int tmp;
						tmp=ivals[j];
						ivals[j]=ivals[j+1];
						ivals[j+1]=tmp;
						s*=-1;
					}
				}
			
			ChangeList(lh[0],ct_g5_l[0]);
			ChangeList(lh[1],ct_g5_l[1]);
			ChangeList(lh[2],ct_g5_l[2]);
			ChangeList(lh[3],ct_g5_l[3]);
			SetCompoundArg(ListFirst(l),1,
				NewInteger(s*IntegerValue(CompoundArg1(ListFirst(l)))));
			
			ct_res1=ct_add_si(ct_res1,ListFirst(l));
		}
		RemoveList(ct_res);
		ct_res=ct_res1;
		for(l=ct_res;l;l=ListTail(l))
			SetCompoundArg(ListFirst(l),1,NewInteger(IntegerValue(
					CompoundArg1(ListFirst(l)))/24));
	}
	
	return ct_res;
}
