#include <stdio.h>
#include "terms.h"
#include "ga.h"

static int vind;
int p_vect, p_spin;
int vect_inds;
int exclude_PN = 0;
int prtspin[8];

static int mcmp(Term t1, Term t2)
{
	int i1, i2;
	i1=IntegerValue(t1);
	if(i1<0)
		i1=-i1;
	i2=IntegerValue(t2);
	if(i2<0)
		i2=-i2;
	if(i1>i2)
		return 1;
	else
		return -1;
}

static List simply_mom(List l)
{
	List lret,l1;
	lret=NewList();
	
	for(l1=l;l1;l1=ListTail(l1))
	{
		List l2;
		int no;
		no=IntegerValue(ListFirst(l1));
		for(l2=lret;l2;l2=ListTail(l2))
		{
			if(IntegerValue(ListFirst(l2))==no)
			{
				printf("Error: twice moment (line %d)\n",CurrentInputLine());
				exit(0);
			}
			if(IntegerValue(ListFirst(l2))==-no)
			{
				lret=CutFromList(lret,l2);
				break;
			}
		}
		if(is_empty_list(l2))
			lret=AppendLast(lret,NewInteger(no));
	}
	FreeAtomic(l);
	
	return lret;
}



static void check_mom(List diag)
{
	List l1;
	List ls=NewList();
	for(l1=diag;l1;l1=ListTail(l1))
	{
		List l2;
		for(l2=CompoundArgN(ListFirst(l1),3);l2;l2=ListTail(l2))
			ls=ConcatList(ls,CopyTerm(ListFirst(l2)));
		
		ls=simply_mom(ls);
		if(ls)
		{
			printf("Momenta determination failure (line %d).\n",CurrentInputLine());
			exit(0);
		}
		for(l2=CompoundArgN(ListFirst(l1),3);l2;l2=ListTail(l2))
		{
			ChangeList(l2,SortedList(ListFirst(l2),mcmp));
			if(!exclude_PN)
			{
				List l3,l4;
				int n,s;
				l3=ListFirst(l2);
				n=0;
				for(l4=l3;l4;l4=ListTail(l4))
					if(IntegerValue(ListFirst(l4))<=in_prt+out_prt &&
							IntegerValue(ListFirst(l4))>=-in_prt-out_prt)
						n++;
				if(n+n>in_prt+out_prt)
				{
					n=IntegerValue(ListFirst(l3));
					if((n>0 && n<=in_prt) || n<-in_prt)
						s=1;
					else
						s=-1;
					l4=NewList();
					for(n=1;n<=in_prt;n++)
						l4=AppendLast(l4,NewInteger(-n*s));
					for(n=in_prt+1;n<=in_prt+out_prt;n++)
						l4=AppendLast(l4,NewInteger(n*s));
					l3=ConcatList(l3,l4);
					l3=simply_mom(l3);
					l3=SortedList(l3,mcmp);
					ChangeList(l2,l3);
				}
			}
		}
	}
	
	

}



static int ajout_mom(List diag1)
	{
	List diag;
	int chfl=0;
	diag=diag1;
	while(!is_empty_list(diag))
		{
		List l1,l2;
		int eno=0;
		l1=CompoundArgN(ListFirst(diag),3);
		while(!is_empty_list(l1))
			{
			if(ListFirst(l1)==0)
				eno++;
			l1=ListTail(l1);
			}
		if(eno==1)
			{
			List newm, newm1;
			newm=newm1=NewList();
			l1=CompoundArgN(ListFirst(diag),3);
			while(!is_empty_list(l1))
				{
				if(ListFirst(l1))
					{
					l2=ListFirst(l1);
					while(!is_empty_list(l2))
						{
						newm1=AppendLast(newm1,ListFirst(l2));
						l2=ListTail(l2);
						}
					}
				l1=ListTail(l1);
				}
			newm1=simply_mom(newm1);
			newm=CopyTerm(newm1);
			l1=newm;
			while(!is_empty_list(l1))
				{
				ChangeList(l1,NewInteger(-IntegerValue(ListFirst(l1))));
				l1=ListTail(l1);
				}
			l1=CompoundArg2(ListFirst(diag));
			l2=CompoundArgN(ListFirst(diag),3);
			while(!is_empty_list(l1))
				{
				if(ListFirst(l2)==0)
					{
					int i,vno, pno;
					ChangeList(l2,newm);
					vno=IntegerValue(CompoundArg1(ListFirst(l1)));
					pno=IntegerValue(CompoundArg2(ListFirst(l1)));
					l1=diag1;
					for(i=1;i<vno;i++)
						l1=ListTail(l1);
					l2=CompoundArgN(ListFirst(l1),3);
					for(i=1;i<pno;i++)
						l2=ListTail(l2);
					ChangeList(l2,newm1);
					chfl=1;
					break;
					}
				l1=ListTail(l1);
				l2=ListTail(l2);
				}
			
			}
		diag=ListTail(diag);
		}
		
	return chfl;
	}		





static int ajout_lm(List diag1, int nm)
	{
	List diag;
	diag=diag1;
	

	while(!is_empty_list(diag))
		{
		List l1,l2;
		int eno=0;
		l1=CompoundArgN(ListFirst(diag),3);
		while(!is_empty_list(l1))
			{
			if(ListFirst(l1)==0)
				eno++;
			l1=ListTail(l1);
			}
		if(eno==2)
			{
			l1=CompoundArg2(ListFirst(diag));
			l2=CompoundArgN(ListFirst(diag),3);
			while(!is_empty_list(l1))
				{
				if(ListFirst(l2)==0)
					{
					int i,vno, pno;
					ChangeList(l2,AppendFirst(0,NewInteger(nm)));
					vno=IntegerValue(CompoundArg1(ListFirst(l1)));
					pno=IntegerValue(CompoundArg2(ListFirst(l1)));
					l1=diag1;
					for(i=1;i<vno;i++)
						l1=ListTail(l1);
					l2=CompoundArgN(ListFirst(l1),3);
					for(i=1;i<pno;i++)
						l2=ListTail(l2);
					ChangeList(l2,AppendFirst(0,NewInteger(-nm)));
					while(ajout_mom(diag1));
					return 1;
					break;
					}
				l1=ListTail(l1);
				l2=ListTail(l2);
				}
			}
		diag=ListTail(diag);
		}	
	
	diag=diag1;
	while(!is_empty_list(diag))
		{
		List l1,l2;
		int eno=0;
		l1=CompoundArgN(ListFirst(diag),3);
		while(!is_empty_list(l1))
			{
			if(ListFirst(l1)==0)
				eno++;
			l1=ListTail(l1);
			}
		if(eno)
			{
			l1=CompoundArg2(ListFirst(diag));
			l2=CompoundArgN(ListFirst(diag),3);
			while(!is_empty_list(l1))
				{
				if(ListFirst(l2)==0)
					{
					int i,vno, pno;
					ChangeList(l2,AppendLast(0,NewInteger(nm)));
					vno=IntegerValue(CompoundArg1(ListFirst(l1)));
					pno=IntegerValue(CompoundArg2(ListFirst(l1)));
					l1=diag1;
					for(i=1;i<vno;i++)
						l1=ListTail(l1);
					l2=CompoundArgN(ListFirst(l1),3);
					for(i=1;i<pno;i++)
						l2=ListTail(l2);
					ChangeList(l2,AppendLast(0,NewInteger(-nm)));
					while(ajout_mom(diag1));
					return 1;
					break;
					}
				l1=ListTail(l1);
				l2=ListTail(l2);
				}
			}
		diag=ListTail(diag);
		}	
	return 0;
	
	}


static void ajout_xmom(List diag)
{
	List l1;
	List ls=NewList(),lsm;
	int pno;
	for(l1=diag;l1;l1=ListTail(l1))
	{
		List l2;
		for(l2=CompoundArgN(ListFirst(l1),3);l2;l2=ListTail(l2))
			ls=ConcatList(ls,CopyTerm(ListFirst(l2)));
		ls=simply_mom(ls);
		if(ls)
			break;
	}
	
	if(!ls)
	{
		puts("Internal error (ajxm).");
		exit(0);
	}
	

	
	pno=0;
	for(l1=ls;l1;l1=ListTail(l1))
	{
		int thisno;
		thisno=IntegerValue(ListFirst(l1));
		if(thisno<0)
			thisno=-thisno;
		if(thisno>pno)
			pno=thisno;
	}
	
	if(pno<=in_prt+out_prt)
	{
		puts("Internal error (ajxmi).");
		exit(0);
	}
	
	for(l1=ls;l1;l1=ListTail(l1))
	{
		if(IntegerValue(ListFirst(l1))==-pno)
		{
			ls=CutFromList(ls,l1);
			break;
		}
		if(IntegerValue(ListFirst(l1))==pno)
		{
			ls=CutFromList(ls,l1);
			for(l1=ls;l1;l1=ListTail(l1))
				ChangeList(l1,NewInteger(-IntegerValue(ListFirst(l1))));
			break;
		}
		if(ListTail(l1)==0)
		{
			puts("Internal error (ajxms)");
			exit(0);
		}
	}
	
	lsm=CopyTerm(ls);
	for(l1=lsm;l1;l1=ListTail(l1))
		ChangeList(l1,NewInteger(-IntegerValue(ListFirst(l1))));

/*	
printf(" p%d=",pno);WriteTerm(ls);puts("");
printf("-p%d=",pno);WriteTerm(lsm);puts("");
*/
		
	for(l1=diag;l1;l1=ListTail(l1))
	{
		List l2;
		for(l2=CompoundArgN(ListFirst(l1),3);l2;l2=ListTail(l2))
		{
			List l3,l4;
			l3=ListFirst(l2);
			for(l4=l3;l4;l4=ListTail(l4))
			{
				if(IntegerValue(ListFirst(l4))==pno)
				{
					l3=CutFromList(l3,l4);
					l3=ConcatList(l3,CopyTerm(ls));
					l3=simply_mom(l3);
					ChangeList(l2,l3);
					break;
				}
				if(IntegerValue(ListFirst(l4))==-pno)
				{
					l3=CutFromList(l3,l4);
					l3=ConcatList(l3,CopyTerm(lsm));
					l3=simply_mom(l3);
					ChangeList(l2,l3);
					break;
				}
			}
		}
	}
	
	FreeAtomic(ls);
	FreeAtomic(lsm);
	
	for(l1=diag;l1;l1=ListTail(l1))
	{
		List l2;
		for(l2=CompoundArgN(ListFirst(l1),3);l2;l2=ListTail(l2))
		{
			List l3;
			for(l3=ListFirst(l2);l3;l3=ListTail(l3))
			{
				int vn;
				vn=IntegerValue(ListFirst(l3));
				if(vn>pno)
					ChangeList(l3,NewInteger(vn-1));
				if(vn<-pno)
					ChangeList(l3,NewInteger(vn+1));
			}
		}
	}
	
		
				

}

	
				

int  gen_mom(Term diag)
	{
	List l;
	int vno=0;
	diag=CompoundArg2(diag);
	
	{
		int i;
		for(i=0;i<8;i++) prtspin[i]=0;
	}

	l=diag;
	while(!is_empty_list(l))
		{
		List l_1, l_2;
		int pno=0;
		vno++;
		l_1=CompoundArg1(ListFirst(l));
		l_2=CompoundArg2(ListFirst(l));
		while(!is_empty_list(l_1))
			{
			pno++;
			if(is_integer(ListFirst(l_2)) && IntegerValue(ListFirst(l_2))<50)
				{
				int tov;
				int pno1=0;
				Atom ap;
				List m_1,m_2;
				tov=IntegerValue(ListFirst(l_2));
				ap=GetAtomProperty(ListFirst(l_1),A_ANTI);
				if(!is_atom(ap))
					{
					printf("Can not find antiparticle for '");
					WriteTerm(ListFirst(l_1));
					puts("'; check the model.");
					exit(0);
					}
				ChangeList(l_2,0);
				m_1=CompoundArg1(ListNth(diag,tov));
				m_2=CompoundArg2(ListNth(diag,tov));
				while(!is_empty_list(m_1))
					{
					pno1++;
					if(ListFirst(m_1)==ap && ListFirst(m_2)==NewInteger(vno))
						{
						ChangeList(l_2,MakeCompound2(OPR_DIV,NewInteger(tov),NewInteger(pno1)));
						ChangeList(m_2,MakeCompound2(OPR_DIV,NewInteger(vno),NewInteger(pno)));
						break;
						}
					m_1=ListTail(m_1);
					m_2=ListTail(m_2);
					}
				if(is_empty_list(m_1))
					{
					puts("Internal error (cplf)");
					exit(0);
					}
				}
			l_1=ListTail(l_1);
			l_2=ListTail(l_2);
			}
		l=ListTail(l);
		}		
	

	
	l=diag;
	while(!is_empty_list(l))
		{
		List l1,l2;
		
		l1=CompoundArg2(ListFirst(l));
		l2=NewList();
		
		while(!is_empty_list(l1))
			{
			int no;
			if(is_integer(ListFirst(l1)))
				{
				no=IntegerValue(ListFirst(l1));
				if(no<200)
					l2=AppendLast(l2,AppendLast(0,NewInteger(100-no)));
				else
					{
					if(no-200<out_prt)
						l2=AppendLast(l2,AppendLast(0,NewInteger(no-200+in_prt)));
					else
						{
						List l3;
						int i3;
						l3=NewList();
						for(i3=1;i3<in_prt+out_prt;i3++)
							l3=AppendLast(l3,NewInteger(i3<=in_prt?i3:-i3));
						l2=AppendLast(l2,l3);
						}
					}
				}
			else
				l2=AppendLast(l2,NewList());
			l1=ListTail(l1);
			}
		
		SetCompoundArg(ListFirst(l),3,l2);
		l=ListTail(l);
		}
		
	

		
	while(ajout_mom(diag));
	

		
	{
	int lno=0;
	while(ajout_lm(diag,in_prt+out_prt+lno+1))
		lno++;
	
	while(lno>loop_no)
	{
		ajout_xmom(diag);
		lno--;
	}
	
	
	if(lno!=loop_no)
		{
		DumpList(diag);
		printf("Error: mom gen: %d loops expected, %d got (line %d).\n",loop_no,lno,
				CurrentInputLine());
		exit(0);
		}
	}
	

	check_mom(diag);
	
	
	l=diag;
	vind=p_vect=p_spin=1;
	while(!is_empty_list(l))
		{
		List l1,l2,lvi,lvp;
		lvi=NewList();
		lvp=NewList();
		l1=CompoundArg1(ListFirst(l));
		l2=CompoundArg2(ListFirst(l));
		while(!is_empty_list(l1))
			{
			List ind;
			List i1;
			Atom polve;
			polve=0;
			i1=NewList();
			ind=GetAtomProperty(ListFirst(l1),PROP_INDEX);
			if(!is_empty_list(ind))
				{
				Term rpr;
				char cbuf[8];
				rpr=CompoundArg1(ListFirst(ind));
				if(CompoundName(rpr)==A_LORENTZ && 
					CompoundArg1(rpr)==NewInteger(2) &&
					CompoundArg2(rpr)==NewInteger(2))
						{
						sprintf(cbuf,"m%d",vind);
						vind++;
						i1=AppendLast(i1,NewAtom(cbuf,0));
						ind=ListTail(ind);
						if(!is_empty_list(ind))
							{
							rpr=CompoundArg1(ListFirst(ind));
							if(CompoundName(rpr)==A_LORENTZ && 
								CompoundArg1(rpr)==NewInteger(2) &&
								CompoundArg2(rpr)==NewInteger(2))
								{
								sprintf(cbuf,"m%d",vind);
								vind++;
								i1=AppendLast(i1,NewAtom(cbuf,0));
								}
							}
						}
					}
			
			if(is_integer(ListFirst(l2)) && 
				(ind=GetAtomProperty(ListFirst(l1),PROP_INDEX)))
				{
				char cbuf[8];
				ind=CompoundArg1(ListFirst(ind));
				if(CompoundName(ind)==A_LORENTZ)
					{ 
					if(
					CompoundArg1(ind)==NewInteger(2) &&
					CompoundArg1(ind)==NewInteger(2) )
						{
						int v;
						v=IntegerValue(ListFirst(l2));
						if(v>200)
							v=v-200+in_prt;
						if(v>100)
							v-=100;
						sprintf(cbuf,"e%d",v);
						prtspin[v]=2;
						p_vect++;
						polve=NewAtom(cbuf,0);
						}
					else
						{
						int v;
						v=IntegerValue(ListFirst(l2));
						if(v>200)
							v=v-200+in_prt;
						if(v>100)
							v-=100;
						sprintf(cbuf,"s%d",v);
						prtspin[v]=1;
						p_spin++;
						polve=NewAtom(cbuf,0);
						}
					}
				}	
			lvp=AppendLast(lvp,polve);	
			lvi=AppendLast(lvi,i1);
			l1=ListTail(l1);
			l2=ListTail(l2);
			}
		SetCompoundArg(ListFirst(l),4,lvi);
		SetCompoundArg(ListFirst(l),7,lvp);
		l=ListTail(l);
		}
		
	vect_inds=vind-1;
	p_vect--;
	p_spin--;
	
	
	return 1;	
	}
	
