#include <stdio.h>
#include "terms.h"
#include "ga.h"
		
int cf_num, cf_den;
List cf_sym;
		

static Term l2s(List l)
	{
	if(ListLength(l)==1)
		return ListFirst(l);
	return MakeCompound2(OPR_MLT,l2s(ListTail(l)),ListFirst(l));
	}

static void wrt_s(List l, FILE *f)
	{
	List l1,l2,l0;
	l0=l;
	l1=l2=NewList();
	while(!is_empty_list(l0))
		{
		int pw;
		pw=IntegerValue(CompoundArg2(ListFirst(l0)));
		if(pw>0)
			l1=AppendLast(l1,ListFirst(l0));
		else
			{
			SetCompoundArg(ListFirst(l0),2,NewInteger(-pw));
			l2=AppendLast(l2,ListFirst(l0));
			}
		l0=ListTail(l0);
		}
	RemoveList(l0);
	l=l1;
	while(!is_empty_list(l))
		{
		if(CompoundArg2(ListFirst(l))==NewInteger(1))
			{
			Atom a;
			a=CompoundArg1(ListFirst(l));
			FreeAtomic(ListFirst(l));
			ChangeList(l,a);
			}
		l=ListTail(l);
		}
	l=l2;
	while(!is_empty_list(l))
		{
		if(CompoundArg2(ListFirst(l))==NewInteger(1))
			{
			Atom a;
			a=CompoundArg1(ListFirst(l));
			FreeAtomic(ListFirst(l));
			ChangeList(l,a);
			}
		l=ListTail(l);
		}
		
	if(l1)
		{
		l=l2s(l1);
		RemoveList(l1);
		l1=l;
		}
		
	if(l2)
		{
		l=l2s(l2);
		RemoveList(l2);
		l2=l;
		}
	
	fprintf(f,"ComSymFact:=");
	
	if(l1==0 && l2==0)
		{
		fprintf(f,"1$\n");
		return;
		}
	
	if(l1==0)
		{
		fprintf(f,"1/(");
		fWriteTerm(f,l2);
		fprintf(f,")$\n");
		FreeAtomic(l2);
		return;
		}
		
	if(l2==0)
		{
		fWriteTerm(f,l1);
		fprintf(f,"$\n");
		FreeAtomic(l1);
		return;
		}
		
	fWriteTerm(f,l1);	
	fprintf(f,"/(");
	fWriteTerm(f,l2);
	fprintf(f,")$\n");
	FreeAtomic(l1);
	FreeAtomic(l2);
	
	}
			

static List add_mlt(List all, List mlt)
	{
	List l1;
	while(!is_empty_list(mlt))
		{
		Term t1;
		t1=ListFirst(mlt);
		l1=all;
		while(!is_empty_list(l1))
			{
			if(CompoundArg1(ListFirst(l1))==CompoundArg1(t1))
				{
				SetCompoundArg(ListFirst(l1),2,
					NewInteger(IntegerValue(CompoundArg2(ListFirst(l1))) +
							   IntegerValue(CompoundArg2(t1))));
				goto cnt;
				}
			l1=ListTail(l1);
			}
		all=AppendLast(all,CopyTerm(t1));
	cnt:
		mlt=ListTail(mlt);
		}
	return all;
	}
	
static void rd_fact(List *l, int *num, int *den)
	{
	List l1;
bg1:
	l1=*l;
	while(!is_empty_list(l1))
		{
		if(CompoundArg2(ListFirst(l1))==NewInteger(0))
			{
			*l=CutFromList(*l,l1);
			goto bg1;
			}
		l1=ListTail(l1);
		}
	l1=*l;
	while(!is_empty_list(l1))
		{
		if(CompoundArg1(ListFirst(l1))==A_SQRT2)
			{
			int pw;
			pw=IntegerValue(CompoundArg2(ListFirst(l1)));
			while(pw<0)
				{
				pw+=2;
				*den*=2;
				}
			while(pw>1)
				{
				pw-=2;
				*num*=2;
				}
			if(pw==0)
				*l=CutFromList(*l,l1);
			else
				SetCompoundArg(ListFirst(l1),2,NewInteger(1));
			break;
			}
		l1=ListTail(l1);
		}
			
	}		
	

void wrt_c_f(Term d, FILE *outf)
	{
	List l1,l2;
	int num=1,den=1,c_f;
	l1=CompoundArg2(d);
	l2=NewList();
	while(!is_empty_list(l1))
		{
		Term a2;
		a2=CompoundArgN(ListFirst(l1),5);
		num*=IntegerValue(CompoundArg1(CompoundArg2(a2)));
		den*=IntegerValue(CompoundArg2(CompoundArg2(a2)));
		l2=add_mlt(l2,CompoundArgN(a2,3));
		l1=ListTail(l1);
		}
		
	
	rd_fact(&l2,&num,&den);	
	
	c_f=gcf(num,den);
	num/=c_f;
	den/=c_f;
	fprintf(outf,"ComNumFact:=%d/%d$\n",num,den);
	
	wrt_s(l2,outf);

	
	
	}
	
void ext_c_f(Term d)
	{
	List l1,l2;
	int num=1,den=1,c_f;
	l1=CompoundArg2(d);
	l2=NewList();
	while(!is_empty_list(l1))
		{
		Term a2;
		Term tt;
		a2=CompoundArgN(ListFirst(l1),5);
		tt=ConsumeCompoundArg(a2,2);
		num*=IntegerValue(CompoundArg1(tt));
		den*=IntegerValue(CompoundArg2(tt));
		FreeAtomic(tt);
		tt=ConsumeCompoundArg(a2,3);
		l2=add_mlt(l2,tt);
		FreeAtomic(tt);
		l1=ListTail(l1);
		}
		
	
	rd_fact(&l2,&num,&den);	
	
	c_f=gcf(num,den);
	num/=c_f;
	den/=c_f;
	
	cf_num=num;
	cf_den=den;
	cf_sym=l2;
	
	}
