#include <stdio.h>
#include "terms.h"
#include "ga.h"

int color_factor=0;
List color_str;
	
static int ind_len(Label la, List di)
{
	List l1,l2,l3;
	for(l1=di;l1;l1=ListTail(l1))
	{
		l2=CompoundArg1(ListFirst(l1));
		l3=CompoundArgN(ListFirst(l1),8);
		for(;l2;l2=ListTail(l2),l3=ListTail(l3))
		{
			if(CompoundArg1(ListFirst(l3))==la)
			{
				Term prp;
				prp=GetAtomProperty(ListFirst(l2),A_COLOR);
				if(!is_compound(prp))
				{
					puts("Internal error (pcil)");
					exit(0);
				}
				if(CompoundArg1(prp)==NewInteger(3))
					return 8;
				else
					return 3;
			}
		}
		
	}
	puts("Internal error (ilsf)");
	exit(0);
	return 0;
}
		

static int cnv_l(void)
{
	List l;
	for(l=color_str;l;l=ListTail(l))
	{
		Term t;
		t=ListFirst(l);
		if(strcmp(AtomValue(CompoundName(t)),"Lambda")==0 &&
				CompoundArg1(t)==CompoundArg2(t))
			return 1;
	}
	return 0;
}

static int cnv_f(void)
{
	List l;
	for(l=color_str;l;l=ListTail(l))
	{
		Term t,a1,a2,a3;
		t=ListFirst(l);
		if(strcmp(AtomValue(CompoundName(t)),"F")==0)
		{
			a1=CompoundArg1(t);
			a2=CompoundArg2(t);
			a3=CompoundArgN(t,3);
			if(a1==a2 || a2==a3 || a1==a3)
				return 1;
		}
	}
	return 0;
}

static int cnv_dlt(List di)
{
	List l;
	for(l=color_str;l;l=ListTail(l))
	{
		Term t,a;
		t=ListFirst(l);
		if(strcmp(AtomValue(CompoundName(t)),"delta")==0 && 
				CompoundArg1(t)==CompoundArg2(t))
		{
			a=CompoundArg1(t);
			color_str=CutFromList(color_str,l);
			color_factor*=ind_len(a,di);
			return 1;
		}
	}
	return 0;
}


static Term get_label(List ci, Integer i)
{
	for(;ci;ci=ListTail(ci))
		if(CompoundArg1(ListFirst(ci))==i)
			return CompoundArg2(ListFirst(ci));
	puts("Integnal error (pcgl)");
	exit(0);
	return 0;
}
		
static List add_num_i(List ci, Integer i)
{
	List l;
	for(l=ci;l;l=ListTail(l))
		if(CompoundArg1(ListFirst(l))==i)
			return ci;
	return AppendLast(ci,MakeCompound2(OPR_DIV,i,NewLabel()));
}

static int num_in_p(Integer i, List ci)
{
	for(;ci;ci=ListTail(ci))
		if(CompoundArg1(ListFirst(ci))==i)
			return 1;
	return 0;
}

static int eListMember(List l, Term t)
	{
	int i=1;
	while(!is_empty_list(l))
		{
		if(EqualTerms(ListFirst(l),t))
			return l;
		i++;
		l=ListTail(l);
		}
	return 0;
	}

static int rdc_dlt(List *th)
{
	List l1;
	Term ad,av;
	ad=av=0;
	for(l1=*th;l1;l1=ListTail(l1))
	{
		Term a1,a2;
		a1=CompoundArg1(ListFirst(l1));
		a2=CompoundArg2(ListFirst(l1));
		if(CompoundName(ListFirst(l1))==A_DELTA && a1!=a2 &&
				(!is_integer(a1) || !is_integer(a2)))
		{
			if(is_integer(a1))
			{
				Term a3;
				a3=a1;
				a1=a2;
				a2=a3;
			}
			ad=a1;
			av=a2;
			*th=CutFromList(*th,l1);
			break;
		}
	}
	if(ad==0)
		return 0;
	for(l1=*th;l1;l1=ListTail(l1))
	{
		int i,ca;
		Term tht;
		tht=ListFirst(l1);
		ca=CompoundArity(tht);
		for(i=1;i<=ca;i++)
			if(CompoundArgN(tht,i)==ad)
				SetCompoundArg(tht,i,av);
	}
	return 1;
}
			

int proc_color(Term diag)
{
	int i,j;
	List l1, l2;
	List prp_dlt;
	
	color_factor=1;

	for(l1=CompoundArg2(diag);l1;l1=ListTail(l1))
	{
		List l3,l4;
		l4=NewList();
		l3=CompoundArg2(ListFirst(l1));
		for(l2=CompoundArg1(ListFirst(l1));l2;l2=ListTail(l2),l3=ListTail(l3))
		{
			Term prp;
			prp=GetAtomProperty(ListFirst(l2),A_COLOR);
			if(prp==0)
				l4=AppendLast(l4,0);
			else
			{
				prp=CopyTerm(prp);
				if(is_integer(ListFirst(l3)))
					SetCompoundArg(prp,1,ListFirst(l3));
				else
					SetCompoundArg(prp,1,NewLabel());
				l4=AppendLast(l4,prp);
			}
		}
		SetCompoundArg(ListFirst(l1),8,l4);
	}
	
	
	prp_dlt=NewList();
	i=0;
	for(l1=CompoundArg2(diag);l1;l1=ListTail(l1))
	{
		List l3;
		i++;
		j=0;
		l3=CompoundArg2(ListFirst(l1));
		for(l2=CompoundArgN(ListFirst(l1),8);l2;l2=ListTail(l2),l3=ListTail(l3))
		{
			j++;
			if(ListFirst(l2) && is_label(CompoundArg1(ListFirst(l2))))
			{
				int i1,j1;
				i1=IntegerValue(CompoundArg1(ListFirst(l3)));
				j1=IntegerValue(CompoundArg2(ListFirst(l3)));
				if(i1>i || (i1==i && j1>j))
				{
					Term l4;
					l4=CompoundArg2(diag);
					l4=ListNth(l4,i1);
					l4=CompoundArgN(l4,8);
					l4=ListNth(l4,j1);
					l4=CompoundArg1(l4);
					if(!is_label(l4))
						puts("Internal error (pcrnyx)");
					prp_dlt=AppendLast(prp_dlt,
							MakeCompound2(A_DELTA,CompoundArg1(ListFirst(l2)),l4));
				}
			}
		}
	}

/*
DumpList(CompoundArg2(diag));
*/
	i=0;
	for(l1=CompoundArg2(diag);l1;l1=ListTail(l1))
	{
		Term a2,m2;
		List ci,thcs;
		i++;
		
		ci=NewList();
		thcs=NewList();
		j=0;
		a2=CompoundArgN(ListFirst(l1),5);
		
		for(l2=CompoundArg1(a2);l2;l2=ListTail(l2))
		{
			Term prp;
			j++;
			prp=GetAtomProperty(CompoundArg1(ListFirst(l2)),A_COLOR);
			if(prp)
			{
				int ino;
				Term lbl;
				
				ino=IntegerValue(CompoundArg2(prp));
				ino=ListNth(CompoundArg1(CompoundArg2(ListFirst(l2))),ino);
				lbl=ListNth(CompoundArgN(ListFirst(l1),6),j);
				lbl=CompoundArg1(ListNth(CompoundArgN(ListFirst(l1),8),IntegerValue(lbl)));
				ci=AppendLast(ci,MakeCompound2(OPR_DIV,ino,lbl));
			}
			
		}
		
		m2=ListFirst(CompoundArgN(a2,5));
		for(l2=CompoundArgN(m2,3);l2;l2=ListTail(l2))
		{
			Term sp;
			int h_c;
			List l3;
			sp=ListFirst(l2);
			h_c=0;
			for(l3=CompoundArg2(sp);l3;l3=ListTail(l3))
				if(num_in_p(ListFirst(l3),ci))
					h_c=1;
			
			if(h_c)
			{
				thcs=AppendLast(thcs,CopyTerm(sp));
				for(l3=CompoundArg2(sp);l3;l3=ListTail(l3))
					ci=add_num_i(ci,ListFirst(l3));
			}
		}

		for(l2=CompoundArgN(a2,5);l2;l2=ListTail(l2))
		{
			List l3,l5,l6;
			m2=ListFirst(l2);
			l3=ConsumeCompoundArg(m2,3);
			for(l5=thcs;l5;l5=ListTail(l5))
			{
				l6=eListMember(l3,ListFirst(l5));
				if(l6)
					l3=CutFromList(l3,l6);
				else
				{
					printf("Error (Line %d): vertex ",CurrentInputLine());
					WriteVertex(CompoundArg1(a2));
					puts(" has bad color structure.");
					exit(0);
				}
			}
			SetCompoundArg(m2,3,l3);
		}

		for(l2=thcs;l2;l2=ListTail(l2))
		{
			Term sp,sp1;
			sp=ListFirst(l2);
			ChangeList(l2,0);
			if(CompoundArg1(sp)==A_DELTA)
			{
				ChangeList(l2,MakeCompound2(A_DELTA,
						get_label(ci,ListFirst(CompoundArg2(sp))),
						get_label(ci,ListNth(CompoundArg2(sp),2))));
				FreeAtomic(sp);
			}
			else if(strcmp(AtomValue(CompoundArg1(sp)),"lambda")==0)
			{
				sp1=MakeCompound(NewAtom("Lambda",0),3);
				SetCompoundArg(sp1,1,get_label(ci,ListNth(CompoundArg2(sp),1)));
				SetCompoundArg(sp1,2,get_label(ci,ListNth(CompoundArg2(sp),2)));
				SetCompoundArg(sp1,3,get_label(ci,ListNth(CompoundArg2(sp),3)));
				FreeAtomic(sp);
				ChangeList(l2,sp1);
			}
			else if(strcmp(AtomValue(CompoundArg1(sp)),"f_SU3")==0)
			{
				sp1=MakeCompound(NewAtom("F",0),3);
				SetCompoundArg(sp1,1,get_label(ci,ListNth(CompoundArg2(sp),1)));
				SetCompoundArg(sp1,2,get_label(ci,ListNth(CompoundArg2(sp),2)));
				SetCompoundArg(sp1,3,get_label(ci,ListNth(CompoundArg2(sp),3)));
				FreeAtomic(sp);
				ChangeList(l2,sp1);
			}
			else
			{
				printf("Internal error (line %d): unknown color object ",
						CurrentInputLine());
				WriteTerm(sp);
				printf(", vertex");
				WriteVertex(CompoundArg1(a2));
				puts(".");
				exit(0);
			}
		}
									
	FreeAtomic(ci);
	prp_dlt=ConcatList(prp_dlt,thcs);
	}
	
	
	while(rdc_dlt(&prp_dlt));
	
	color_str=prp_dlt;
	

	
	if(cnv_l() || cnv_f())
	{
		color_factor=0;
	}
	
	while(cnv_dlt(CompoundArg2(diag)));
	
	
/*	
	{
		puts("");
		WriteTerm(CompoundArg1(diag));
		WriteTerm(color_str);printf("  cf=%d\n",color_factor);
	}
*/		
	
	return 1;
}

	
