
#include <stdio.h>
#include "terms.h"
#include "ga.h"

List params=0, prtcls=0, vertices=0;

void alg2_common_t(Term a2)
	{
	List ct, l1,l2,l3,l4, ml, gct;
	ct=NewList();
	
	ml=CompoundArgN(a2,5);
	if(is_empty_list(ml) || ListLength(ml)==1 )
		return;
	gct=CompoundArgN(ListFirst(ml),3);
	if(is_empty_list(gct))
		return;
		
	l1=gct;
	while(!is_empty_list(l1))
		{
		Term spt;
		spt=ListFirst(l1);
		l2=ListTail(ml);
		while(!is_empty_list(l2))
			{
			l3=CompoundArgN(ListFirst(l2),3);
			while(!is_empty_list(l3))
				{
				if(EqualTerms(spt,ListFirst(l3)))
					break;
				l3=ListTail(l3);
				}
			if(is_empty_list(l3))
				goto cnt1;
			l2=ListTail(l2);
			}
		ct=AppendLast(ct,CopyTerm(spt));
	cnt1:
		l1=ListTail(l1);
		}
	
	if(is_empty_list(ct))
		return;
	
	l1=ml;
	while(!is_empty_list(l1))
		{
		Term m2;
		m2=ListFirst(l1);
		l2=ConsumeCompoundArg(m2,3);
		l3=ct;
		while(!is_empty_list(l3))
			{
			Term rt;
			rt=ListFirst(l3);
			l4=l2;
			while(!is_empty_list(l4))
				{
				if(EqualTerms(ListFirst(l4),rt))
					{
					l2=CutFromList(l2,l4);
					goto cnt2;
					}
				l4=ListTail(l4);
				}
			puts("Internal error (a2ctf).");
		cnt2:
			l3=ListTail(l3);
			}
		SetCompoundArg(m2,3,l2);
		l1=ListTail(l1);
		}
	SetCompoundArg(a2,4,ct);
	
	}



static int store_v(Term a2)
	{
	vertices=AppendLast(vertices,a2);
	return 1;
	}

int readd(void)
	{
	Term rt;
	int i;
	if(itrIn()!=NewAtom("parameters",0))
		{
		puts("Wrong format of vertices file");
		return 0;
		}
	if(Verbose)
		{
		fprintf(stderr,"reading model parameters... ");
		fflush(stdout);
		}
	while((rt=itrIn())!=A_END)
		{
		params=AppendFirst(params,rt);
		SetAtomProperty(CompoundName(rt),PROP_TYPE,OPR_PARAMETER);
		}
	for(i=1;i<9;i++)
	{
		char cbuf[8];
		Atom p;
		sprintf(cbuf,"s%d",i);
		p=NewAtom(cbuf,0);
		params=AppendFirst(params,MakeCompound2(p,NewFloat(-1),0));
	}
	if(Verbose)
		{
		fprintf(stderr,"done\nreading model particles... ");
		fflush(stdout);
		}
	while((rt=itrIn()) 
	      && is_compound(rt) 
	      && CompoundName(rt)==OPR_PARTICLE)
		{
		Atom nm;
		List lp,l;
		nm=ConsumeCompoundArg(rt,1);
		FreeAtomic(rt);
		lp=itrIn();
		if(!is_list(lp))
			{
			puts("Wrong format of vertices file");
			return 0;
			}
		l=lp;
		while(!is_empty_list(l))
			{
			Term prop;
			prop=ConsumeCompoundArg(ListFirst(l),1);
			SetAtomProperty(nm,CompoundName(ListFirst(l)),prop);
			l=ListTail(l);
			}
		FreeAtomic(lp);
		prtcls=AppendFirst(prtcls,nm);
		}
	if(Verbose)
		{
		fprintf(stderr,"done.\nreading model vertices...\n");
		}
	
	i=0;
	do
		{
		if(rt==0)
			{
			if(i==0)
				{
				puts("No vertices.");
				return 0;
				}
			else
				return 1;
			}
		if(!is_compound(rt) || CompoundName(rt)!=A_ALG2)
			{
			puts("Error in model file.");
			return 0;
			}
		i++;
		if(Verbose && (i%10)==0)
			{
			fprintf(stderr,"%5d\r",i);
			fflush(stderr);
			}
		if(store_v(rt)==0)
			return 0;
		} while((rt=itrIn()));
	fprintf(stderr,"done.         \n");
	return 1;
	}
	
