#include <stdio.h>

typedef signed long Atom, Integer, Float,
		Atomic, Functor, Term, Compound, List, Label;

/*
typedef void *List;
*/



	/*   File data.c  */

int 	is_atomic(Term), is_compound(Term), is_functor(Atomic),
	is_atom(Atomic), is_float(Atomic), is_integer(Atomic);

void 	InitAtoms(void);

Atom 	NewAtom(char *s, int len);
char 	*AtomValue(Atom);
void    SetAtomProperty(Atom a, Atom type, Term value);
Term    GetAtomProperty(Atom a, Atom type);
void    RemoveAtomProperty(Atom a, Atom type);
Term    AtomProperties(Term,Term);


Float 	NewFloat(double d);
double 	FloatValue(Float);

Integer	NewInteger(long val);
long 	IntegerValue(Integer i);

Functor NewFunctor(Atom name, int arity);
Atom 	FunctorName(Functor f);
int 	FunctorArity(Functor f);

Compound NewCompound(Functor f);
Functor CompoundFunctor(Compound c);
Term    CompoundArg1(Compound c);
Term    CompoundArg2(Compound c);
Term    CompoundArgN(Compound c, int arg);
Term    ConsumeCompoundArg(Compound c, int arg);
void    SetCompoundArg(Compound c, int arg, Term t);
Compound MakeCompound(Atom name, int Arity);
Compound MakeCompound1(Atom name, Term arg1);
Compound MakeCompound2(Atom name, Term arg1, Term arg2);
Compound MakeCompound3(Atom name, Term arg1, Term arg2, Term arg3);
Atom	CompoundName(Compound c);
int     CompoundArity(Compound c);

Atomic  NewLabel(void);
int 	LabelValue(Atomic l);

void 	FreeAtomic(Atomic);
Term	CopyTerm(Term);
int 	EqualTerms(Term,Term);
char 	AtomicType(Atomic);
int 	is_atomic(Atomic a);
int 	is_float(Atomic a);
int 	is_integer(Atomic a);
int 	is_atom(Atomic a);
int 	is_functor(Atomic a);
int 	is_compound(Term a);
int 	is_list(Term a);
int     is_label(Atomic a);

void 	AtomStatistics(void);


	/*  File lexic.c  */
	
int  	SetInputFile(char *name);
void 	CloseInputFile(void);
Atomic 	ReadAtomic(void);
void  	UnreadAtomic(Atomic);
char 	*CurrentInputFile(void);
int   	CurrentInputLine(void);
void 	WritePrompt(int );
void 	SkipInputLine(void);
int 	IsTermInput(void);

	/* File write.c  */
	
int  DisplayTerm(Term);
int  WriteTerm(Term);
int  fWriteTerm(FILE *, Term);
int  fDisplayTerm(FILE *, Term);

extern int AlwaysBracets, WideWriting;

	/* File lists.c */
	
List NewList(void);
int  is_empty_list(List);
Term ListFirst(List);
List ListTail(List);
List AppendFirst(List,Term);
List AppendLast(List,Term);
List SortedList(List li, int (*cmp)(Term,Term));
List ListSplit(List, List, List *);
List CutFromList(List l, List c);
void FreeList(List l);
void RemoveList(List l);
int  ListLength(List l);
Term ListNth(List l, int arg);
List ListNthList(List l, int arg);
void ChangeList(List l, Term nv);
void InsertList(List l, Term ins);
void DumpList(List l);
void ListStatistics(void);
List ConcatList(List, List);
int  ListMember(List, Term);
List IntersectList(List, List);
List MakeList2(Term,Term);
List MakeList3(Term,Term,Term);
List MakeList4(Term,Term,Term,Term);


	/* File  ops.c  */

void SetOperator(Atom name, Atom assoc, int prior);
Compound  GetOperator(Atom name, Atom type, Atom *assoc, int *prior);
Compound  CurrentOperator(int no);

#define OP_NONE		0
/*
#define OP_PREFIX	1
#define OP_INFIX	2
#define OP_POSTFIX	3
*/
	/*	File  parse.c */

Term ReadTerm(void);
Term ReadDisplTerm(void);

extern int ExitOnError;

List CommaToList(Term t);
void ErrorInfo(int);
void ReplAtom(Term, Atom, Atom);

#include "atoms.h"

int  itrSetOut(char *);
void itrOut(Term);
void itrCloseOut(void);
int  itrSetIn(char *);
Term itrIn(void);
void itrCloseIn(void);
